/*b:еgrid layout⣬Ժ滻table,ÿ6û*/
FS.ButtonsTable = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<table/>').attr('id', 'fs_auth_role_userstable');
		this.tb = $('<tbody/>').appendTo(this.element);
		this.container = config.container;
		if (config.items) {
			this.generateUserButtons(config.items);
		}
	},
	
	generateUserButtons : function(items) {
		this.items = items;
		var leng = items.length;
		var self = this;
		for(var i = 0, len = Math.ceil(leng/6); i < len; i++) {
			var tr = $('<tr/>');
			for (var j = 6; j--;) {
				var b = 6*i + 6 - j - 1;
				if (b >= leng) {
					break;
				}
				var rb = new FS.RemoveSelfButton({
					text : items[b].text
				});
				rb.element.data('item', items[b]);
				rb.on(FS.Events.REMOVESELF, function() {
					var user = this.element.data('item');
					self.container.removeSelf(user);
					self.removeUser(user);					
				});
				$('<td/>').append(rb.element).appendTo(tr);
			}
			tr.appendTo(this.tb);
		}
	},
	
	
	popUsers : function(users){
		if (FR.equals(users, this.items)) {			
			return;
		}
		this.clearContent();
		this.generateUserButtons(users);
	},
	
	getUsers : function() {
		return this.items;
	},
	
	getUsersID : function() {
		if(!this.items) {
			return;
		}
		return $.map(this.items, function(item) {
			return item.id;
		});
	},
	
	removeUser : function(user) {
		this.items.remove(user);
		this.reBuildTable();
	},
	
	reBuildTable : function() {
		this.clearButtons();
		this.generateUserButtons(this.items);
	},
	
	clearButtons : function() {
		this.tb.empty();
	},
	
	clearContent : function() {
		this.tb.empty();
		this.items = null;
	}
});

/*b:add remove icon*/
FS.RemoveSelfButton = FR.extend(FS.Button, {
	_defaultConfig : function() {
		return $.extend(FS.RemoveSelfButton.superclass._defaultConfig.apply(), {
			width : 60,
			height : 20
		});
	},
	_init : function() {
		FS.RemoveSelfButton.superclass._init.apply(this, arguments);
		this.element.addClass('fs_removeself');
		//b:float
		var self = this;
		var removeIcon = $('<span>&nbsp;</span>').addClass('fs_buttonremoveself').css('float', 'right').click(function() {
			self.fireEvent(FS.Events.REMOVESELF);
			self.element.remove();
		});
		if(!isNaN(this.$btn.width())) {
			this.$btn.width(this.$btn.width() - 10);
		}
		$('em', this.element).parent().prepend(removeIcon);
	}
});

/* b:grid ʱֻṩҳӺadd
 * ֮ʱȫⲿʵֻ֣ṩƳݵĽӿڣƳⲿɾ̨ݿ
 *   sortmultidrag, resize,Զwidget(widgetɱ)Ӻʵ
 * Ҫ֧Զؼ
 */
FS.Grid = FR.extend(FR.Widget, {
	_defaultConfig : function() {
		return $.extend(FS.Grid.superclass._defaultConfig.call(), {
			cls : '',
			selfbar : '',
			drag : false,
			resize : false,
			page : true,
			multi : false,
			pagecount : 10,
			columnsconfig : [{text : 'test', width : 120, sort: false, hide : false, widget : {type : 'text', items : []}}],
			items : [{test : 'hello'}, {test : 'world'}], 
			width : 500,
			height : 200,
			intervalcolor : false
		});
	},
	
	_init : function() {
		FS.Grid.superclass._init.apply(this, arguments);
		this.confireWidth();
		this.element.addClass('fs_grid').addClass(this.options.cls);
		this.titlePane();
		this.toolbarPane();
		this.headPane();
		this.tablePane();
		this.footPane();
		this.element.append(this.toolbarDom ? this.toolbarDom : '')
			.append(this.tableContainer).append(this.foot ? this.foot : '');
	},
	
	confireWidth : function() {
		var width = 0;
		for(var i = 0, len = this.options.columnsconfig.length; i < len; i++) {
			width += this.options.columnsconfig[i].width;	
		}
		this.options.width = width;
		this.element.width(width);
	},
		
	titlePane : function() {
		if (this.options.title != null) {
			this.titleDom = $('<div/>').attr('id', 'fs_grid_title').text(this.options.title);
			this.element.append(this.titleDom);
		}		
	},
	
	toolbarPane : function() {
		if (this.options.selfbar) {
			this.toolbarDom = $('<div/>').attr('id', 'fs_grid_toolbar').append(this.options.selfbar);
		}
	},
	
	headPane : function() {
		var h = (this.options.selfbar ? 30 : 0) + (this.options.page ? 22 : 0) + (this.options.title != null ? 20 : 0);
		this.tableContainer = $('<div/>').attr('id', 'fs_grid_tablecontainer').width(this.options.width).height(this.options.height - h);
		this.table = $('<table/>').attr({id : 'fs_grid_table', cellPadding : 0, cellSpacing : 0}).appendTo(this.tableContainer);
		this.head = $('<thead/>').attr('id', 'fs_grid_head');
		this.buildHead();
		this.table.append(this.head);
	},
	
	buildHead : function() {
		var tr = $('<tr/>').appendTo(this.head);
		if (this.options.multi) {
			this.multiHead();
		}
		var cc = this.options.columnsconfig;
		for (var i = 0, len = cc.length; i < len; i++) {
			var th = $('<th/>').addClass('fs_grid_headcontent'), config = cc[i];
			th.width(config.width).text(config.showValue ? config.showValue : config.text);
			if (config.sort) {
				this.sortHead(th);
			}
			if (config.hide) {
				this.hideHead(th);
			}
			tr.append(th);
		}
		if (this.options.drag) {
			this.dragHead();
		}
		if (this.options.resize) {
			this.resizeHead();
		}
	},
	
	//b:head仯bodyű仯
	rebuildFields : function(columnconfig) {
		if (columnconfig) {
			this.options.columnsconfig = columnconfig;
		}
		this.head.empty();
		this.buildHead();
		this.clearBody();
	},
	
	/*b:ʱȫ*/
	tablePane : function() {
		this.tbody = $('<tbody/>').attr('id', 'fs_grid_tbody');
		this.renderActivePage();
		this.table.append(this.tbody);
	},
	
	footPane : function() {
		if (!this.options.page) {
			return;
		}
		this.foot = $('<div/>').attr('id', 'fs_grid_foot');
		this.totalpages = Math.ceil(this.options.items.length/this.options.pagecount);
		var table = $('<table/>').attr({id : 'fs_grid_foot_table', cellPadding : 0, cellSpacing : 0});
		var self = this;
		this.mf = new FS.IconButton({
			renderEl : $('<div/>'),
			imgsrc : 'fs_grid_foot_movefirst',
			handler : function() {
				self.move2FirstPage();
			}
		}); 
		this.mp = new FS.IconButton({
			renderEl : $('<div/>'),
			imgsrc : 'fs_grid_foot_movepre',
			handler : function() {
				self.move2PrePage();
			}
		}); 
		this.mn = new FS.IconButton({
			renderEl : $('<div/>'),
			imgsrc : 'fs_grid_foot_movenext',
			handler : function() {
				self.move2NextPage();
			}
		}); 
		this.ml = new FS.IconButton({
			renderEl : $('<div/>'),
			imgsrc : 'fs_grid_foot_movelast',
			handler : function() {
				self.move2LastPage();
			}
		});
		this.activedPage = this.totalpages ? 1 : 0;
		this.pageLoader = $('<input id="fs_grid_foot_loader" type="text" />').val(this.activedPage).keydown(function(e) {
			if (e.keyCode == 13) {
				self.move2AppointPage($(this).val());
				e.stopEvent();
			}			
		});
		this.totalPane = $('<span/>').text("" + this.totalpages + "ҳ");
		$('<tr/>').append($('<td/>').append(this.mf.element)).append($('<td>').append(this.mp.element))
			.append($('<td/>').addClass('fs_grid_foot_pageshow').append(this.pageLoader).append(this.totalPane))
			.append($('<td/>').append(this.mn.element)).append($('<td/>').append(this.ml.element)).appendTo(table);
		this.foot.append(table);
		this.checkFootButtonState();
	},
	
	checkFootButtonState : function() {
		if (!this.mf) {
			return;
		}
		if (this.activedPage < 2) {
			this.mf.setEnable(false);
			this.mp.setEnable(false);
		} else {
			this.mf.setEnable(true);
			this.mp.setEnable(true);
		}
		if (this.activedPage == this.totalpages) {
			this.mn.setEnable(false);
			this.ml.setEnable(false);
		} else if (this.activedPage < this.totalpages && this.totalpages > 1) {
			this.mn.setEnable(true);
			this.ml.setEnable(true);
		}		
	},
	
	move2NextPage : function() {
		++this.activedPage;
		this.renderActivePage();
	},
	
	move2PrePage : function() {
		--this.activedPage;
		this.renderActivePage();
	},
	
	move2FirstPage : function() {
		this.activedPage = 1;
		this.renderActivePage();
	},
	
	move2LastPage : function() {
		this.activedPage = this.totalpages;
		this.renderActivePage();
	},
	
	move2AppointPage : function(index) {
		if (index < 1 || index > this.totalpages) {
			FR.Msg.toast("ָҳڣ룡");
			return;
		}
		if (this.activedPage == index) {
			return;
		}
		this.activedPage = index;
		this.checkFootButtonState();
		this.renderActivePage();
	},
	
	renderActivePage : function() {
		this.clearBody();
		if (!this.activedPage) {
			this.activedPage = 1;
		}
		if (this.pageLoader) {
			this.pageLoader.val(this.activedPage);
		}
		var startIndex = (this.activedPage - 1)*this.options.pagecount;
		var self = this, ilen = this.options.items.length;
		for (var i = startIndex, len = Math.min(this.options.pagecount + startIndex,  ilen); i < len; i++) {
			var item = this.options.items[i];
			var tr = $('<tr/>').click(function() {
				if (self.activedTR) {
					self.activedTR.removeClass('fs_grid_selectedtr');
				}
				$(this).addClass('fs_grid_selectedtr');
				self.activedTR = $(this);
				self.fireEvent(FS.Events.SELECTDATA);
			});
			for (var j = 0, jen = this.options.columnsconfig.length; j < jen; j++) {	
				var cc = this.options.columnsconfig[j];
				var proper = cc.text;
				if(proper == 'password') {
					var val = '********';
				} else if(proper) {
					var val = item[proper];
				} else {
					var val = '';
				}
				var td = $('<td/>').addClass('fs_grid_td');
				if (cc.showWidget && cc.widget) {
					var widget = FR.createWidget(cc.widget);
					if (widget.setValue) {
						widget.setValue(val);
					}
					//b:߿Դø
					widget.element.data('index', i);
					td.append(widget.element);
				} else {
					td.text(val);
				}
				td.appendTo(tr);			
			}
			if (this.options.intervalcolor && (i - startIndex)%2 == 0) {
				tr.addClass('fs_grid_intervaltr');
			}
			tr.appendTo(this.tbody);
		}
		this.checkFootButtonState();
	},
	
	clearBody : function() {
		this.tbody.empty();
		this.activedTR = null;
		this.fireEvent(FS.Events.NOSELECT);
	},
	
	getIndexData : function(index) {
		return this.options.items[index];
	},
	
	getSelectedData : function() {
		if (!this.options.multi) {			
			return [this.options.items[this.getSelectedIndex()[0]]];
		}
	},
	
	getSelectedIndex : function() {
		if (!this.options.multi) {
			if (!this.activedTR) {
				return;
			}
			var trs = $('tr', this.tbody);
			for (var i = 0, len = trs.length; i < len; i++) {
				if (trs[i] == this.activedTR[0]) {
					return [this.options.pagecount*(this.activedPage - 1) + i];
				}
			}
		}
	},
	
	reCalculator : function() {
		var pages = Math.ceil(this.options.items.length/this.options.pagecount);
		if (this.totalpages != pages) {
			this.totalpages = pages;
			this.totalPane.text("" + this.totalpages + "ҳ");
		}
		
		if (this.activedPage > this.totalpages) {
			this.activedPage = this.totalpages;			
		}	
		if (!this.activedPage && this.totalpages) {
			this.activedPage = 1;
		}
		this.renderActivePage();
	},
	
	addData : function(item) {
		if (item == null) {
			return;
		}
		if (!this.fireEvent(FS.Events.APPENDDATA, item)) {
			return;
		}
		if (!$.isArray(item)) {
			item = [item];
		}
		Array.prototype.unshift.apply(this.options.items, item);
//		this.options.items.unshift(item);
			var si = this.getSelectedIndex();
		this.reCalculator();
		if (!this.options.multi) {
			this.activedTR = $('tr.fs_grid_selectedtr', this.tbody).eq((si ? si[0] : 0) + item.length);
			/*b:ѡҪע*/
			if (!this.activedTR[0]) {
				this.fireEvent(FS.Events.NOSELECT);
			} else {
				this.activedTR.addClass('fs_grid_selectedtr');
			}
		}

	},
	
	removeSelectedData : function() {
		var rs = this.getSelectedData();
		/*b:ɾʱ*/
		if (!this.fireEvent(FS.Events.REMOVEDATA, rs[0])) {
			FR.Msg.toast("Grid removedata failed!");
			return;
		}
		/*b:Ƚϸӵķʽto improve*/
		for (var i = 0, len = rs.length; i < len; i++) {
			this.options.items.remove(rs[i]);
		}
		this.reCalculator();
		this.activedTR = null;
		this.fireEvent(FS.Events.NOSELECT);
	},
	
	changeSelectedData : function(item) {
		var si = this.getSelectedIndex();
		this.options.items[si[0]] = $.extend(this.options.items[si[0]], item);
		if (!this.fireEvent(FS.Events.EDITDATA, this.options.items[si[0]])) {
			FR.Msg.toast("Grid editdata failed!");
			return;		
		}
		this.reCalculator();
		if (!this.options.multi) {
			this.activedTR = $('tr', this.tbody).eq(si[0]).addClass('fs_grid_selectedtr');
			this.fireEvent(FS.Events.SELECTDATA);
		}
	},
	
	popData : function(items) {
		if (items == null) {
			this.clearBody();
			this.options.items = [];
			return;
		}
		
		this.options.items = items;
		this.reCalculator();
	},
	
	loading : function(load) {
	
	},
	
	createDialogTable : function(item) {
		var self = this;
		var dt = this.dt = $('<table/>').attr('cellSpacing', 6).addClass('fs_grid_dialogtable');
		var cc = this.options.columnsconfig;
		if(item) {
			$.each(cc, function(idx, item) {
				if(item.text == 'password') {
					cc.splice(idx, 1, {
						text : 'password',
						showValue : '',
						width : 200,
						widget : {type : 'button', text : '', width : 120, height : 20, 
						handler : function() {
							var item = self.getDialogTableContent();
							item.password = '123456';
							self.changeSelectedData(item);
							$('.fs_griddialog').after($('<span>ûѾΪ123456</span>').css({
								'color' : 'red',
								'pading-top' : '5px',
								'padding-left' : '10px'
							}));
						}
						}
					});	
				}
			});
		} else {
			$.each(cc, function(idx, item) {
				if(item.text == 'password') {
					cc.splice(idx, 1, {
						text : 'password',
						showValue : '',
						width : 200,
						widget : {type : 'text', passwordText : true, allowBlank : false, errorMsg :  '벻Ϊգ'}
					});	
				}
			});
		}
		this.tds = [];
		for (var i = 0, len = cc.length; i < len; i++) {
			var config = cc[i];
			if (!config.widget) {
				continue;
			}
			var ntd = $('<td/>').addClass('fs_grid_dialogtdname');
			var widget = FR.createWidget(config.widget);
			ntd.data('widget', widget);
			ntd.data('text', config.text);
			$('<tr/>').append(ntd.text((config.showValue != null ? config.showValue : config.text) + ":")).append($('<td/>').append(widget.element)).appendTo(dt);
			this.tds.push(ntd);
		}
	},
	
	clearDialogTableContent : function() {
		var tds = this.tds;
		for (var i = 0, len = tds.length; i < len; i++) {
			var widget = tds[i].data('widget');
			if (widget && widget._setValue) {
				//b:֤,not all widget
				widget._setValue('');
			}
		}
	},
	
	setDialogTableContent : function(item) {
		if (!item) {
			return;
		}
		var tds = this.tds;
		for (var i = 0, len = tds.length; i < len; i++) {
			var widget = tds[i].data('widget');
			if (widget) {
				if(widget.options.type == 'button') {
					widget.setValue('');
				} else {
					widget.setValue(item[tds[i].data('text')]);
				}
			}
		}
	},
	
	getDialogTableContent : function() {
		var tds = this.tds;
		var content = {};
		for (var i = 0, len = tds.length; i < len; i++) {
			var widget = tds[i].data('widget');
			if(widget.options.type == 'button') {
				continue ;
			}
			if (!widget.isValidate()) {
				FR.Msg.toast(widget.errorMsg);
    			return;
			}
			content[tds[i].data('text')] = widget.getValue();
		}
		return content;
	},
	
	showAddOrEditDialog : function(item) {
		var position = this.table.offset();
		this.editItem = item;
//		if (this.adDialog && !item) {			
//			this.adDialog.setTitle(item ? '༭' : '');
//			this.clearDialogTableContent();
//			this.adDialog.modifyPosition(position);
//			this.adDialog.setVisible(true);
//			return;
//		}
		var content = $('<div/>').addClass('fs_griddialog');
		this.createDialogTable(item);
 		content.append(this.dt);
 		item ? this.setDialogTableContent(item) : this.clearDialogTableContent();
 		var self = this;
 		var confire = function() {
 				var item = self.getDialogTableContent();
 				if (!item) {
 					return false;
 				}
 			 	if (self.editItem) {
 					self.changeSelectedData(item);
 				} else {
 					self.addData(item);
 				}
 				self.itemChanged = true;
 		};
 		var height = this.options.columnsconfig.length*26 + 90;
 		this.adDialog = new FS.Dialog({
 			title : (item ? '༭' : ''),
 			width:300,
 			height : height,
 			content : content,
 			confire : confire,
 			position : position
 		});
	},
	
	uiAddData : function() {
		this.showAddOrEditDialog();
	},
	
	uiEditData : function() {
		this.showAddOrEditDialog(this.getSelectedData()[0]);
	},
	
	uiRemoveData : function() {
		var self = this;
		FS.showConfirmDialog({
			position : this.table.offset(),
			callback : function() {
				self.removeSelectedData();
				self.itemChanged = true;
			}
		});
	},
	
	multiHead : function() {
		
	},
	
	sortHead : function(th) {
		
	},
	
	sortItems : function() {
		
	},
	
	hideHead : function() {
		
	},
	
	resizeHead : function() {
		
	},
	
	dragHead : function() {
		
	}
});


/*b:ʱҪǲʱݲӺ error*/
$.extend(FS.Trans,  {
		orgnizeTree : FR.servletURL + '?op=fs_entry&cmd=getfolder',
					 	
	 	getAllReports : function() {	
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallreports"
	 		});
	 	},
	 	
	 	getAllModules : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallmodules"
	 		});
	 	},
	 	
	 	getReportParas : function(report) {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_entry&cmd=genparameters",
	 			data : {reportPath : report}
	 		});
	 	},
	 	
	 	getRoles : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallrole"
	 		});
	 	},
	 	
	 	saveRole : function(role, reportPrivilege, processPrivilege, modulePrivilege, users) {
	 		var url = FR.servletURL + "?op=fs_set&cmd=";
	 		if (role.postid != null || role.departmentid != null) {
	 			url += "auth_addjrole"
	 		} else {
	 			url += "auth_addsrole"
	 		}
	 		return this.ajax({
	 			returnString : true,
	 			data : {
	 				role : role,
	 				reports_add : reportPrivilege.add ? reportPrivilege.add : [],
	 				reports_remove : reportPrivilege.remove ? reportPrivilege.remove : [],
	 				process_add : processPrivilege.add ? processPrivilege.add : [],
	 				process_remove : processPrivilege.remove ? processPrivilege.remove : [],
	 				modules_add : modulePrivilege.add ? modulePrivilege.add : [],
	 				modules_remove : modulePrivilege.remove ? modulePrivilege.remove : [],
	 				users : users ? users : []
	 				},
	 			url : url
	 		});
	 	},
	 	
	 	getRoleAuth : function(role) {
	 		var url = FR.servletURL + "?op=fs_set&cmd=";
	 		if (role.postid != null || role.departmentid != null) {
	 			url += "auth_getjroleauth"
	 		} else {
	 			url += "auth_getsroleauth"
	 		}
	 		return this.ajax({
	 			data : {id : role.id},
	 			url : url
	 		});
	 	},
	 	
	 	removeRole : function(role) {
	 		var url = FR.servletURL + "?op=fs_set&cmd=";
	 		if (role.postid != null || role.departmentid != null) {
	 			url += "auth_removejrole"
	 		} else {
	 			url += "auth_removesrole"
	 		}
	 		this.ajax({
	 			data : {id : role.id},
	 			url : url
	 		});
	 	},
	 	
	 	getRoleUsers : function(role) {
	 		return this.ajax({
	 			data : {id : role.id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getsroleusers"
	 		});
	 	},
	 	
	 	addRoleUsers : function(role, users) {
	 		return this.ajax({
	 			data : {
	 				id : role.id,
	 				usersid : users
	 				},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getsroleusers"
	 		});
	 	},
	 	
	 	updateRoleUsers : function(role, users) {
	 		return this.ajax({
	 			data : {
					id : role.id,
	 				usersid : users
					},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_updatesroleusers"
	 		});
	 	},
	 	
	 	removeRoleUser : function(role, userid) {
	 		this.ajax({
	 			data : {id : role.id, userid : userid},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removesroleuser"
	 		});
	 	},
	 	
	 	getDepartUsers : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getdepartusers"
	 		});
	 	},
	 	
	 	addRoleUsers : function(rid, uids) {
	 		this.ajax({
	 			data : {
	 				id : rid,
	 				usersid : uids
	 			},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_addsroleusers"
	 		});
	 	},
	 	
	 	removeRoleUser : function(rid, uid) {
	 		this.ajax({
	 			data : {
	 				id : rid,
	 				userid : uid
	 			},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removesroleuser"
	 		});
	 	},
	 	
	 	getAllDepart : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getalldepart"
	 		});
	 	},
	 	
	 	getSpecialDepart : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getspecialdepart"
	 		});
	 	},
	 	
	 	addDepart : function(depart) {
	 		return this.ajax({
	 			data : {depart : depart},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_adddepart"
	 		});	 		
	 	},
	 	
	 	removeDepart : function(id) {
	 		this.ajax({
	 			data : {id : id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removedepart"
	 		});
	 	},
	 	
	 	getAllPost : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallpost"
	 		});
	 	},
	 	
	 	getSpecialPost : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getspecialpost"
	 		});
	 	},
	 	
	 	addPost : function(post) {
	 		return this.ajax({
	 			returnString : true,
	 			data : {post : post}, 
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_addpost"
	 		});
	 	},
	 	
	 	removePost : function(id) {
	 		this.ajax({
	 			data : {id : id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removepost"
	 		});
	 	},
	 	
	 	getAllEmployee : function(id) {
	 		return this.ajax({
	 			data : {id : id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallemployee"
	 		});
	 	},
	 	
	 	addEmployee : function(employee) {
	 		return this.ajax({
	 			returnString : true,
	 			data : {employee : employee},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_addemployee"
	 		});
	 	},
	 	
	 	removeEmployee : function(id) {
	 		return this.ajax({
	 			data : {id : id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removeemployee"
	 		});
	 	},
	 	
	 	/*b:user isnot in any department*/
	 	getUnallocatedUser : function() {
	 		
	 	},
	 	
	 	getAllUsers : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallusers"
	 		});
	 	},
	 	
	 	getNormalUsers : function() {
	 		return this.ajax({
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_getallusers_nosuper"
	 		});
	 	},
	 	
		addUser : function(user) {
			return this.ajax({
				returnString : true,
				data : {user : user},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_adduser"
	 		});
		},
		
		removeUser : function(id) {
			this.ajax({
				data : {id : id},
	 			url : FR.servletURL + "?op=fs_set&cmd=auth_removeuser"
	 		});
		},

		setBulletin : function(bu) {
			return this.ajax({
				returnString : true,
				url : FR.servletURL + "?op=fs_manager&cmd=addbulletin",
				data : {
					bulletin : bu
					},
				error : function() {
					FR.Msg.toast("Set Bulletin Failed!");
				}
			});
		},
		
		getReportWidgets : function() {
			return this.ajax({
				url : FR.servletURL + "?op=fs_manager&cmd=getallchart"
			});
		},
		
		saveReportWidget : function(report) {
	 		return this.ajax({
				returnString : true,
				url : FR.servletURL + "?op=fs_manager&cmd=addchart",
				data : {chart : report}
			});
	 	},
	 	
	 	removeReportWidget : function(id) {
	 		this.ajax({
	 			url : FR.servletURL + "?op=fs_manager&cmd=removechart",
	 			data : {id : id}
	 		});
	 	}
	}
);

FS.BarList = FS.extend(FS.Widget, {
	init : function(config) {
		this.element=  $('<div/>').attr('id', 'fs_barlist');
		this.resize(config);
		if (config.title) {
			this.title = $('<span/>').css({color : '#598EB7', 'line-height' : '20px'}).text(config.title).appendTo(this.element);
		}
		if (config.barcontent) {
			this.bar = $('<div/>').addClass('fs_barlist_bar').width(config.width).height(24).append(config.barcontent).appendTo(this.element);
		}
		this.generateList(config);
	},
	
	generateList : function(config) {
		this.content = $('<div/>').addClass('fs_barlist_list').appendTo(this.element);
		this.list = new FS.List({
			width : config.width ? config.width : 160,
			height : config.height ? (config.height - this.bar.height() - (this.title ? 20 : 0)) : 300,
			items : config.items,
			renderEl : this.content
		});
	},
	
	/*b:list add selecteditem change event*/
	on : function(name, callback) {
		this.list.on(name, callback);
	},
	
	popData : function(data) {
		this.list.popData(data);
	},
	
	reName : function(name) {
		var data = this.getSelectedData();
		data.text = name;
		this.list.editItem(data);
	},
	
	reData : function(data) {
		this.list.editItem(data);
	},
	
	clearData : function() {
		this.list.doClear();
	},
	
	getSelectedData : function() {
		return this.list.getSelectedData();
	},
	
	getAll : function () {
		return this.list.getAll();
	},
	
	/*b:list to be editable*/
	addData : function(data, isSelected) {
		this.list.addSimpleData(data);
		if (isSelected){
			this.list.setSelectedIndex(this.list.options.data.getLength() - 1);
		}
	},
	
	editSelectedData : function(data) {
		this.list.editItem(data);
	},
	
	removeSelectedData : function() {
		this.list.removeSelect();
	},
	
	getDataLength : function() {
		return this.list.options.data.getLength();
	},
	
	resize : function(config) {
		this.element.width(config.width).height(config.height);
	}
});

FS.BarTree = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_bartree');
		this.resize(config);
		if (config.title) {
			this.title = $('<span/>').css({color : '#598EB7', 'line-height' : '20px'}).text(config.title).appendTo(this.element);
		}
		if (config.barcontent) {
			this.bar = $('<div/>').addClass('fs_bartree_bar').height(24).append(config.barcontent).appendTo(this.element);
		}
		this.generateTree(config);
	},
	
	reBuild : function(treeData) {
		this.tree.reBuild(treeData);
	},
	
	getAllData : function () {
    	return this.tree.options.data.getData();
    },
	
	generateTree : function(config) {
		this.content = $('<div/>').addClass('fs_bartree_tree').appendTo(this.element);
		var config = $.extend(config, {
			width : config.width ? config.width : 160,
			height : config.height ? (config.height - this.bar.height() - (this.title ? 20 : 0)) : 300,
			renderEl : this.content
		});
		this.tree = new FS.Tree(config);
	},
	
	/*b: add selecteditem change event*/
	on : function(name, callback) {
		this.tree.on(name, callback);
	},
	
	/*b:to do*/
	popData : function() {
		
	},
	
	clearData : function() {
		
	},
	
	getSelectedData : function() {
		return this.tree.getSelectedData();
	},
	
	/*b:to be editable*/
	addData : function(data) {
		this.tree.addNode(data);
	},
	
	editSelectedData : function(data) {
		
	},
	
	getSelectedName : function() {
		return this.tree.getSelectedData() == null ? null : this.tree.getSelectedData().getShowValue();
	},
	
	reName : function(name) {
		if (this.tree.getSelectedData() == null) {
			return;
		}
		this.tree.getSelectedData().setShowValue(name);
		this.tree.editNode(this.tree.getSelectedData());
	},
	
	removeSelectedData : function() {
		this.tree.removeNode();
	},
	
	resize : function(config) {
		this.element.width(config.width).height(config.height);
	},
	
	selecteByID : function(ids) {
		this.tree.selecteByID(ids);
	}
});

FS.Design = {};

$.extend(FS.Design, {
	initOP : function() {
		if (this.op) {
			return;
		}
		var self = this;
		/*b:IDף̫*/
		this.op = {
			3 : function() {
				return self.authManager();
			},
			2 : function() {
				return self.reportManager();
			},
			7 :  function() {
				return self.analysisDataManager();
			},
			5 : function() {
				return self.serverConfigManager();
			},
			8 : function() {
				return self.registerManager();
			},
			9 : function() {
				return self.monitorManager();
			},
			10 : function() {
				return self.visitorManager();
			},
			11 : function() {
				return self.logManager();
			},
			12 : function () {
				return self.sysexamManager();
			},
			13 : function () {
				return self.processManager();
			},
			14 : function () {
				return self.showTitleSetting();
			}
		};
	},
	
	//b:to improve
	showDesign : function(module) {
		this.initOP();
		/*
		 * wei : ԺҪģҲΨһģȫkeyidkey̫׸ˣ
		 * һʼݲйһʱ¹idͲ֪ʲôˣȷֵˡ
		 */
		var el;
		if(this.op[module.id]) {
			el = this.op[module.id]();
		}
		var config = {
			title : module.text
		};
		if (typeof el == 'string') {
			config.src = el;
		} else {
			config.contentEl = el;
		}
		FS.tabPane.addItem(config);
	},
	
	resize : function() {
		
	},
	
	processManager : function() {
		FR.$defaultImport('/com/fr/process/web/css/fs_process.css', 'css');
		FR.$defaultImport('/com/fr/process/web/js/jquery.ui.droppable.js', 'js');
		FR.$defaultImport('/com/fr/process/web/js/fs_process_design.js', 'js');
 		FR.$defaultImport('/com/fr/process/web/js/fs_process.js', 'js');
 		if ($.browser.msie && $.browser.version < '9.0') {
 			FR.$defaultImport('/com/fr/web/core/js/excanvas.js', 'js');
 		}
		if (this.processPane) {
			return this.processPane.element;
		}
		this.processPane = new FS.ProcessEditPane({
			width : FS.center.width(),
			height : FS.center.height() - 30
		});
		this.processPane.element.data('container', this.processPane);
		return this.processPane.element;
	},
	
	reportManager : function() {
		return FR.servletURL + '?op=fr_schedule&cmd=schedule_action';
	},
	
	authManager : function() {	
		var state = FS.Trans.getTableDataSyncState();
		if (state.type === 1 && state.isReady == "false"){
				return FR.servletURL + "?op=fs_manager&cmd=tabledata_sync";
		} else {
			/**
			 * ͬݼȨҳ
			 */
			if (this.am) {
				this.am.setType(state.type);
				return this.am.element;
			}
			FR.$defaultImport('/com/fr/fs/web/js/fsauthority.js', 'js');
			this.am = new FS.Auth({
				width : FS.center.width(),
				height : FS.center.height() - 30,
				controlType : state.type
			});
			this.am.element.data('container', this.am);
			return this.am.element;
		}
	},
	
	analysisDataManager : function() {
		return FR.servletURL + '?op=fr_adhoc&cmd=data_ac_set&needTitle=false';
	},
	
	serverConfigManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_server';
	},
	
	registerManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_register';
	},
	
	monitorManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_monitor';
	},
	
	visitorManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_visitor';
	},
	
	logManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_log';
	},
	
	sysexamManager : function() {
		return FR.servletURL + '?op=fs_manager&cmd=module_sysexam';
	},
	
	showTitleSetting : function () {
		return FR.servletURL + '?op=fs_manager&cmd=module_title'
	}
});