 if (!window.FS) {
 	window.FS = {};
 }
 
 FS.IconButton = FR.extend(FR.IconButton, {
  	_defaultConfig : function() {
 		return $.extend(FS.IconButton.superclass._defaultConfig.call(), {
 			height : 21,
 			width : 21,
 			renderEl : $('<span>&nbsp;</span>')
 		});
 	},
 	
 	_init : function() {
 		FS.IconButton.superclass._init.apply(this, arguments);
 		this.element.addClass('fs_iconbutton');
 	}	
});

 /*b:дֻǶdom*/
 FS.Dialog = FR.extend(FR.Widget, {
 	_defaultConfig : function () {
        return $.extend(FS.Dialog.superclass._defaultConfig.apply(), {
            cls : "fs_dialog",
            title : "FS",
            prevent: true,
            closed : true,
            width : 300,
            height : 200,
            buttonHeight : 28,
            draggable : true,
            zdex : 1000,
            content : ''
        });
    },
    
    _init : function() {
    	FS.Dialog.superclass._init.apply(this, arguments);
    	this.element.addClass(this.options.cls).css('z-index', this.options.zdex);
    	this.generateHeader();
    	this.generateBody();
    	this.generateButtons();
    	this.generatePrevent();
    	this.registerDrag();
    	
    	this.element.appendTo($('body'));
    	this.modifyPosition();
    },
    
    generateHeader : function() {
    	this.header = $('<div/>').attr('id', 'fs_dialogheader').width(this.options.width).height(24).appendTo(this.element);
    	this.header.append($('<div/>').addClass('fs_dialog_cl')).append($('<div/>').addClass('fs_dialog_cr'));
    	var headcontainer = $('<div/>').addClass('fs_dialogheadercontainer').width(this.options.width - 12).appendTo(this.header);
    	
    	headcontainer.append($('<div/>').addClass('fs_dialogtitle').text(this.options.title));
    	if (this.options.closed) {
    		var self = this;
    		this.headclose = $('<a>&nbsp;</a>').attr('id', 'fs_dialogheaderclose').appendTo(headcontainer);
    		this.headclose.mouseover(function() {
    			$(this).addClass('fs_mousein');
    		}).mouseout(function() {
    			$(this).removeClass('fs_mousein');
    		}).click(function() {
    			self.closeDialog();
    		});
    	}
    },
    
    setTitle : function(title) {
    	$('.fs_dialogtitle', this.header).text(title);
    },
    
    generateBody : function() {
    	this.content = $('<div/>').attr('id', 'fs_dialogcontent').width(this.options.width - 2).css('top', 24).appendTo(this.element);
    	if (this.options.height > 24) {
            this.content.height(this.options.height - 24 - this.options.buttonHeight);//wei : 28ȷȡťĸ߶
        }
    	this.content.append(this.options.content);
    },
    
    reBuildBody : function(content) {
    	this.options.content = content;
    	this.content.empty();
    	this.content.append(this.options.content);
    },
    
    generateButtons : function() {
    	if (!this.options.confire && !this.options.alert) {
    		return;
    	}
    	var buttoncontent = $('<div/>').addClass('fs_dialog_buttons').css({
        	'position' : 'absolute',
        	width : this.options.width - 2
        });
 		var self = this;
 		var confirmButton = new FS.Button({
 			text : 'ȷ',
 			width : 64,
 			height : 24,
 			handler : function() {
 				self.options.confire();
 				self.closeDialog();
 			}
 		});
 		if (this.options.alert) {
 			buttoncontent.width(68);
 			this.element.append(buttoncontent.append(confirmButton.element.addClass('fs_confirebutton')));
 			return;
 		}
 		var cancleButton = new FS.Button({
 			text : 'ȡ',
 			width : 64,
 			height : 24,
 			handler : function() {
 				self.closeDialog();
 			}
 		});
 		this.element.append(buttoncontent.append(confirmButton.element.addClass('fs_confirebutton')).append(cancleButton.element.addClass('fs_canclebutton')));

    },
    
    generatePrevent : function() {
    	if (this.options.prevent) {
    		this.prevent = $('<div/>').attr('id', 'fs_dialogprevent').addClass('fr-window-mask').appendTo($('body')).css('z-index', this.options.zdex - 1);
    		var area = this.pageArea();
    		this.prevent.width(area.width).height(area.height);
    	}
    },
    
    pageArea : function() {
        if (document.compatMode == 'BackCompat') {
            return {
                width: Math.max(document.body.scrollWidth, document.body.clientWidth),
                height: Math.max(document.body.scrollHeight, document.body.clientHeight)
            }
        } else {
            return {
                width: Math.max(document.documentElement.scrollWidth, document.documentElement.clientWidth),
                height: Math.max(document.documentElement.scrollHeight, document.documentElement.clientHeight)
            }
        }
    },
    
    registerDrag : function() {
    	if (this.options.draggable) {
    		var self = this;
    		var startPosition;
	        this.element.draggable({
		        containment : "parent",
		        handle : this.header,
		        start : function(e) {
		                startPosition = {
		                    x:e.clientX,
		                    y:e.target.clientY
		                };
		        },
		        stop : function(e) {
		        		var el = self.element;
		        		var l = el.css('left'), t = el.css('top');
		        		el.css({left : l + e.clientX - startPosition.x, top : t + e.clientY - startPosition.y});
		            }
		    });
    	}
    },
    
    closeDialog : function() {
    	this.setVisible(false);
    },
    
    setVisible : function(visible) {
    	FS.Dialog.superclass.setVisible.call(this, visible);
    	if (this.prevent) {
    		visible ? this.prevent.show() : this.prevent.hide();
    	}
    },
    
    modifyPosition : function(position) {
    	if (!position) {
    		var doc = $(window);
    		position = this.options.position ? this.options.position : {
    			left : Math.max(0, (doc.width() - this.header.width())/2),
    			top : Math.max(0, (doc.height() - this.header.height() - this.content.height())/2)
    		};
    	}
    	this.element.css({left : position.left, top : position.top});
    },
    
    resize : function(rec) {
    	if (!rec.width && !rec.height) {
    		return;
    	}
    	if (rec.width && rec.width > 0) {
    		this.element.width(rec.width);
    	}
    	if (rec.height && rec.height > 0) {
    		this.element.height(rec.height + this.options.buttonHeight);
    	} 
    	this.modifyPosition();
    }
 });
 
  /*b:FR.button滻image*/
 FS.Button = FR.extend(FR.Button, {
 	_defaultConfig : function() {
 		return $.extend(FS.Button.superclass._defaultConfig.call(), {
 			height : 26,
 			width : 70
 		});
 	},
 	
 	_init : function() {
 		FS.Button.superclass._init.apply(this, arguments);
 		this.element.addClass('fs_button');
 	}
 });
 
  /*b:dialog */
 $.extend(FS, {
	showDialog : function(config) {
		if (this.contentDialog) {
			this.contentDialog.setTitle(config.title);
			this.contentDialog.reBuildBody(config.content);
			
			this.contentDialog.setVisible(true);
			this.contentDialog.resize(config);
			return;
		}
		this.contentDialog = new FS.Dialog(config);
	},
	
	closeDialog : function() {
		if (this.contentDialog) {
			this.contentDialog.setVisible(false);
		}
	},
	
	getCurrentDialog : function() {
		return this.contentDialog;
	},
	
	alertDialog : function(config) {
		if (this.alertDialog) {
			
			return;
		}
	},
	
	showPromoteDialog : function(config) {
		if (this.promoteDialog) {
			this.promoteDialog.config = config;
			this.promoteDialog.setTitle(config.title);
			this.promoteDialog.text.setValue(config.value);
			if (config.message != null) {
				$('.fs_promotecontent span', this.promoteDialog).text(config.message);
			}		
			this.promoteDialog.modifyPosition(config.position);
			this.promoteDialog.setVisible(true);
			return;
		}
		var text = new FS.TextEditor({
			width : 140,
			height : 18
		});
		text.setValue(config.value);
		var content = $('<div/>').addClass('fs_promotecontent').append($('<span/>').text(config.message)).append(text.element);
		var self = this;
		var handler = function() {
			self.promoteDialog.config.callback(text.getValue());
 			self.promoteDialog.closeDialog();
		};
		this.promoteDialog = new FS.Dialog({
 			title : config.title,
 			width : 240,
 			height : 140,
 			content : content,
 			confire : handler,
 			position : config.position
 		});
		this.promoteDialog.config = config;
		this.promoteDialog.text = text;
	},
 	
 	showConfirmDialog : function(config) {
 		if (this.confirmDialog) {
 			this.confirmDialog.config = config;
 			this.confirmDialog.modifyPosition(config.position);
 			this.confirmDialog.setVisible(true);
 			return;
 		}
 		var content = $('<div/>').addClass('fs_confirmdialog');
 		content.append($('<div/>').addClass('fs_confirmdialog_content').text('ȷɾ'));

 		var self = this;
 		var submitHandler = function() {
 			self.confirmDialog.config.callback();
 			self.confirmDialog.closeDialog();
 		};
 		
 		this.confirmDialog = new FS.Dialog({
 			title : 'ɾ',
 			width : 240,
 			height : 120,
 			content : content,
 			confire : submitHandler,
 			position : config.position
 		});
		this.confirmDialog.config = config;
 	}
 });