
$.extend(FS.Trans, {
	getTabledataSyncColumns : function (tabledata) {
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=getTabledataColumns",
			data : {
				tabledata : tabledata
			}
		})
	},
	
	submitTableDataSync : function (res) {
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=editTabledataSync",
			data : {
				res : res
			},
			returnString : true
		})
	}
})

FS.TableDataSyncGuidePane = {
	init : function (tdc) {
		var content = $('<div/>').addClass('fs_tabledata_sync_parent').appendTo($('body'));
		this.content = $('<div/>').addClass('fs_tabledata_sync_content').appendTo(content);
		this.initTitle();
		this.initStepButton();
		this.initfirstPane();
		this.initSecondPane();
		this.initThirdPane();
		this.populate(tdc);
	},
	
	populate : function (tdc){
		if (tdc && (tdc.dsName || tdc.dsName === 0)){
			this.datasetComb.setValue(tdc.dsName);
			this.datasetComb.fireEvent(FR.Events.AFTEREDIT);
			var self = this;
			setTimeout(function(){
				if(tdc.userName != -1) {
					self.userName.setValue(tdc.userName);
				} else {
					self.userName.setSelectedIndex(-1);
				}
				if(tdc.password != -1) {
					self.password.setValue(tdc.password);
				} else {
					self.password.setSelectedIndex(-1);
				}
				if(tdc.department != -1) {
					self.department.setValue(tdc.department);
				} else {
					self.department.setSelectedIndex(-1);
				}
				if(tdc.post != -1){
					self.post.setValue(tdc.post);
				} else {
					self.post.setSelectedIndex(-1);
				}
				if(tdc.name != -1) { 
					self.name.setValue(tdc.name);
				} else {
					self.name.setSelectedIndex(-1);
				}
			}, 400);
		}
	},
	
	initTitle : function () {
		var title = $('<div/>').addClass('fs_tabledata_sync_title').appendTo(this.content)
		$('<span/>').text('ͬݼ').addClass('fs_tabledata_sync_title_text').appendTo(title);	
	},
	
	initStepButton : function () {
		var buttonField = $('<div/>').addClass('fs_tabledata_sync_step').appendTo(this.content);
		var self = this;
		this.firstStep = new FS.ToolbarButton({
			text : 'һ',
			height : 24,
			width : 76,
			handler : function() {
				self.secondStep.element.removeClass('fs_button_selected');
				self.thirdStep.element.removeClass('fs_button_selected');
				self.firstPage.show();		
				if (self.secondPage) {
					self.secondPage.hide();
				}	
				if (self.thirdPage) {
					self.thirdPage.hide();
				}
			}
		});
		this.firstStep.element.addClass('fs_button_selected');
		this.secondStep = new FS.ToolbarButton({
			text : 'ڶ',
			height : 24,
			width : 76,
			handler : function() {
				var oldValue = self.datasetComb.getValue();
				self.datasetComb.rebuild({widgetUrl : FR.servletURL + '?op=fr_adhoc&cmd=ac_tabledata_name'});
				self.datasetComb.setValue(oldValue);
				self.firstStep.element.removeClass('fs_button_selected');
				self.thirdStep.element.removeClass('fs_button_selected');	
				self.secondPage.show();
				if (self.firstPage) {
					self.firstPage.hide();
				}
				if (self.thirdPage) {
					self.thirdPage.hide();
				}		
			}
		});
		var self = this
		this.checkHandler = function () {
			var  pos = -1;
			if (self.datasetComb.getValue() === ""){
				pos = 0;
			}else if (self.userName.getValue() === "") {
				pos = 1;
			}else if (self.password.getValue() === ""){
				pos = 2;
			}else if (self.department.getValue() === ""){
				pos = 3;
			}else if (self.post.getValue() === "") {
				pos = 4;
			}
			return pos;
		};
		this.thirdStep = new FS.ToolbarButton({
			text : '',
			height : 24,
			width : 76,
			noSelected : true,
			handler : function() {
				if (self.checkHandler.call(self) !== -1){
					self.secondStep.fireEvent(FR.Events.CLICK);
					var pos = self.checkHandler.call(self);
					switch(pos){
						case 0:{
							FR.Msg.toast('Ҫѡݼ');
							break;
						}
						case 1: {
							FR.Msg.toast('Ҫѡûֶ');
							break;
						}
						case 2: {
							FR.Msg.toast('Ҫѡֶ');
							break;
						}
						case 3: {
							FR.Msg.toast('Ҫѡֶ');
							break;
						}
						case 4: {
							FR.Msg.toast('Ҫѡְֶ');
							break;
						}
					}
					return;
				}
				self.firstStep.element.removeClass('fs_button_selected');
				self.secondStep.element.removeClass('fs_button_selected');
				this.element.addClass('fs_button_selected');
				self.thirdPage.show();
				if (self.firstPage) {
					self.firstPage.hide();
				}
				if (self.secondPage) {
					self.secondPage.hide();
				}		
			}
		});
		buttonField.append(this.firstStep.element.addClass('fs_sync_first'))
				.append(this.secondStep.element.addClass('fs_sync_second'))
				.append(this.thirdStep.element.addClass('fs_sync_third'));
	},
	
	initfirstPane : function () {
		this.firstPage = $('<div/>').addClass('fs_tabledata_sync_page_first').appendTo(this.content);
		$('<div/>').text('Ҫʹ½һݼ').appendTo(this.firstPage);
		$('<div/>').text('÷ݼֶΣû롢šְλɫ').appendTo(this.firstPage);
		$('<div/>').text('÷ݼ԰ֶΣ').appendTo(this.firstPage);
		$('<a/>').text('鿴').attr('href', 'http://www.finereporthelp.com/help/6/0/5/0.html').attr('target','_blank').appendTo($('<div/>').appendTo(this.firstPage));	
		this.createNextButton(this.firstPage, this.secondStep);
	},
	
	initSecondPane : function () {
		this.secondPage = $('<div/>').addClass('fs_tabledata_sync_page_second').appendTo(this.content);
		this.createSettingTitle().appendTo(this.secondPage);
		$('<div/>').text('ȻΪݾϵͳûϢֶΣ').appendTo(this.secondPage);
		this.createSettingContent().appendTo(this.secondPage);
		this.createNextButton(this.secondPage, this.thirdStep);
		this.secondPage.hide();
	},
	
	createSettingTitle : function () {
		var $table = $('<table cellpadding="0" cellspacing="0" border="0" style="border-spacing:0;"></table>').addClass('fs_tabledata_sync_dataset');
		var $tr = $('<tr/>').appendTo($table);
		$('<td/>').text('ѡոսõķݼ').appendTo($tr);
		this.datasetComb = new FR.ComboBoxEditor({
			renderEl : $('<td/>').appendTo($tr),
			height:20,
			width :120,
			directEdit : false,
			allowBlank : false,
			mode: 'remote',
			widgetUrl : FR.servletURL + '?op=fr_adhoc&cmd=ac_tabledata_name'
		})
		var self = this;
		this.datasetComb.on(FR.Events.AFTEREDIT, function(e){
			var listItem = FS.Trans.getTabledataSyncColumns(this.getValue());
			if (!listItem){
				listItem = {};
				listItem.items = [];
			}
			if (listItem) {
				if(!listItem.items) {
					listItem.items = [];
				}
				self.userName.rebuild(listItem.items);
				self.password.rebuild(listItem.items);
				self.department.rebuild(listItem.items);
				self.post.rebuild(listItem.items);
				self.name.rebuild(listItem.items);
				if (listItem.index) {
					self.userName.setValue(listItem.index.username);
					self.password.setValue(listItem.index.password);
					self.department.setValue(listItem.index.department);
					self.post.setValue(listItem.index.post);
					self.name.setValue(listItem.index.name);
				}
			}	
		})		
		return $table;
	},
	
	createSettingContent : function () {
		var $table = $('<table  cellpadding="0" cellspacing="0" border="0" style="border-spacing:0;"></table>').addClass('fs_tabledata_sync_dataset');
		var $tr = $('<tr/>').appendTo($table);
		$('<td/>').addClass('fs_tabledata_sync_name').text('û').appendTo($tr);
		var config = {
			height:20,
			width :80,
			directEdit : false,
			mode: 'remote',
			items:[]
		}
		this.userName = new FR.ComboBoxEditor($.extend(config, {
			allowBlank : false,
			renderEl : $('<td/>').appendTo($tr)
		}));	
		$('<td/>').width(20).appendTo($tr);
		$('<td/>').addClass('fs_tabledata_sync_name').text('').appendTo($tr);	
		this.name = new FR.ComboBoxEditor($.extend(config, {
			allowBlank : true,
			renderEl : $('<td/>').appendTo($tr)
		}));
		$tr = $('<tr/>').appendTo($table);
		$('<td/>').addClass('fs_tabledata_sync_name').text('룺').appendTo($tr);
		this.password = new FR.ComboBoxEditor($.extend(config, {
			allowBlank : false,
			renderEl : $('<td/>').appendTo($tr)
		}));
		$tr = $('<tr/>').appendTo($table);
		$('<td/>').addClass('fs_tabledata_sync_name').text('ţ').appendTo($tr);
		this.department = new FR.ComboBoxEditor($.extend(config, {
			allowBlank : false,
			renderEl : $('<td/>').appendTo($tr)
		}));
		$tr = $('<tr/>').appendTo($table);
		$('<td/>').addClass('fs_tabledata_sync_name').text('ְλ').appendTo($tr);
		this.post = new FR.ComboBoxEditor($.extend(config, {
			allowBlank : false,
			renderEl : $('<td/>').appendTo($tr)
		}));	
		return $table;
	},
	
	initThirdPane : function () {
		this.thirdPage = $('<div/>').addClass('fs_tabledata_sync_page_third').appendTo(this.content);
		$('<div/>').text('Ѿݼͬã').appendTo(this.thirdPage);
		$('<div/>').text('ɡûϢõݼͬ').appendTo(this.thirdPage);
		this.createNextButton(this.thirdPage);
		this.thirdPage.hide();
	},
	
	createNextButton : function (page, nextButton) {
		var content = $('<div/>').addClass('fs_tabledata_sync_page_bottom').appendTo(page)
		var self = this;
		var next = new FS.ToolbarButton({
			text : nextButton ? 'һ' : '',
			height : 34,
			width : 96,
			noSelected : true,
			handler : function() {
				if (nextButton) {
					nextButton.fireEvent(FR.Events.CLICK);
				} else {
					self.submitTableDataSync();
				}
			}
		});
		next.element.addClass('fs_tabledata_sync_page_bottom_next').appendTo(content);
		var cancel =  new FS.ToolbarButton({
			text : 'ȡ',
			height : 24,
			width : 60,
			noSelected : true,
			handler : function() {
				parent.FS.tabPane.closeTab('û');
			}
		});
		$.each([next, cancel], function(idx, item){
			$(item.element).hover(function(e){
				$(this).addClass('fs_button_hover');
			}, function(e){
				$(this).removeClass('fs_button_hover');
			})
		})
		cancel.element.addClass('fs_tabledata_sync_page_bottom_cancel').appendTo(content);	
	},
	
	submitTableDataSync : function () {
		var res = {};
		var pos = this.checkHandler.call(this);
		if (pos === -1) {
			res.dsName = this.datasetComb.getValue();
			res.userName = this.userName.getValue();
			res.password = this.password.getValue();
			res.department = this.department.getValue();
			res.post = this.post.getValue();
			var name =  this.name.getValue()
			if (name !== ""){
				res.name = name;
			}
			var returnValue = FS.Trans.submitTableDataSync(res);
			if (returnValue == "true"){
				FR.Msg.toast("ͬݼɹ");
				parent.FS.userPane.signOut();
			} else {
				FR.Msg.toast("ͬݼʧܣݼ");
			}
		} else {
			this.thirdStep.fireEvent(FR.Events.CLICK);
		}
	}	
}