$.extend(FS.Trans, {
	getTitleImageIDs : function(){
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=getTitleImageIDs"
		})
	},
	
	setTitleImageID : function(id){
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=setTitleImageID",
			data : {
				id : id
			}
		})
	},
	
	setAllTitleImageIDs : function (idArray){
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=setAllTitleImageIDs",
			data : {
				ids : idArray
			}
		})
	},
	
	setHomePageURL : function (url){
		return FS.Trans.ajax({
			url : FR.servletURL + "?op=fs_manager&cmd=setHomePageURL",
			data : {
				url : url
			},
			returnString : true
		})
	}
})

FS.TitleSettingPane = {
	init : function(){
		var content = $('<div/>').addClass('fs_title_parent').appendTo($('body'));
		this.content = $('<div/>').addClass('fs_title_content').appendTo(content);
		this.initHomePageUrlPane();
		$("<span/>").text('ѡ:').appendTo(this.content);
		this.ids = FS.Trans.getTitleImageIDs();
		this.createTitlePics();
		this.createUpLoad();		
	},
	
	initHomePageUrlPane : function () {
		var table = $('<table  cellpadding="0" cellspacing="0" border="0" style="border-spacing:0;"></table>')
			.css('padding-bottom','10px')
			.appendTo(this.content);
		var $tr = $('<tr/>').appendTo(table);
		$('<span/>').text('ҳURL:').appendTo($('<td/>').appendTo($tr));
		var URLContent = new FR.TextEditor({
			width:510,
			value:parent.FS.homePageURL,
			renderEl : $('<td/>').appendTo($tr)
		});
		var btn = new FR.Button({
			width : 60,
			text : FR.i18n.OK,
			renderEl : $('<td/>').appendTo($tr)
		});
		btn.on(FR.Events.CLICK, function(e){
			var res = FS.Trans.setHomePageURL(URLContent.getValue());
			if(res == "success"){
				FR.Msg.toast(FR.i18n.Successfully)
				parent.FS.homePageURL = URLContent.getValue();
				parent.FS.refreshHomePage(URLContent.getValue())
			} else {
				FR.Msg.toast(FR.i18n.Failed)
			}
		});
	},
	
	createTitlePics : function () {
		if(!this.table) {
			this.table = $('<table/>').addClass('fs_title_pics').appendTo(this.content);
		}
		var self = this;
		self.table.append(self.createImageTR());
		$.each(this.ids, function(idx, item){
			self.table.append(self.createImageTR(item));
		})
	},
	
	rebuildTable : function (upLoads) {
		this.table.empty();
		this.createTitlePics();
		this.createUpLoadTRs(upLoads);
	},
	
	createUpLoadTRs : function(pics) {
		var self = this;
		$.each(pics, function(idx, item){
			self.table.append(self.createImageTR(item.attach_id));
		});
	},
	
	createImageTR : function (id) {
		var $tr = $('<tr/>').addClass('fs_title_pics_tr');
		var $td = $('<td/>')
		.appendTo($tr);
		var $div = $('<div/>').addClass('fs_title_pic_out').appendTo($td).append(
		$('<img/>')
		.addClass('fs_title_pic_wh')
		.attr('src', FR.servletURL 
			+ (id ?('?op=fr_attach&cmd=ah_image&id='+id) :'?op=resource&resource=/com/fr/fs/web/images/logo.jpg')));
		var closeIcon = $('<div/>').addClass('fs_title_pic_close').appendTo($div);
		var self = this;
		closeIcon.click(function(e){
			FS.showConfirmDialog({
				text:'ȷҪɾ˺',
				callback:function(e){
					if (id == parent.FS.titleImgID) {
	            		FS.Trans.setTitleImageID();
						parent.FS.initTitle();
	            	}
					var adds = self.fileUpload.getValue();
					$.each(adds, function(idx, item){
						if (item.attach_id == id) {
							self.fileUpload.removeAttach(item);
						}
					})
					var newIdArray = [];
					$.each(self.ids, function(idx, item){
						if (item != id) {
							newIdArray.push(item);
						}
					})
					self.ids = newIdArray;
					setTimeout(function(e){
						 $.ajax({
				            url : FR.servletURL + "?op=fr_attach&cmd=ah_release",
				            data : {
				                id : id
				            },
				            complete : function(res, status) {
				            	self.fileUpload.fireEvent(FR.Events.AFTEREDIT);
				            }
					 	});
					}, 400);		
				}
			})
			e.stopEvent();
		})
		closeIcon.hide();
		$div.hover(function(e){
			$(this).addClass('fs_title_hover');
			if (id) {
				closeIcon.show();
			}
		}, function(e){
			$(this).removeClass('fs_title_hover')
			closeIcon.hide();
		}).click(function(e){
			$('div.fs_title_pic_out').removeClass('fs_title_selected');
			$(this).addClass('fs_title_selected')
			FS.Trans.setTitleImageID(id);
			parent.FS.initTitle();
		})	
		if ((!id && parent.FS.titleImgID == 'null') || id == parent.FS.titleImgID){
			$div.addClass('fs_title_selected')
		}
		return $tr;
	},
	
	createUpLoad : function () {
		var table = $('<table  cellpadding="0" cellspacing="0" border="0" style="border-spacing:0;"></table>').appendTo(this.content);
		var $tr = $('<tr/>').appendTo(table);
		$('<td/>').append($('<span/>').text('ϴµĺ:')).appendTo($tr);
		this.fileUpload = new FR.MultiFileEditor({
			renderEl : $('<td/>').appendTo($tr),
			text:'',
			width:80,
			accept : '.png.jpg.gif',
			hideFileList : true
		});
		var self = this;
		this.fileUpload.on(FR.Events.AFTEREDIT, function(e){
			var adds = this.getValue();
			var newArray = []
			$.each(self.ids, function(idx, item){
				newArray.push(item);
			})
			$.each(adds, function(idx, item){
				newArray.push(item.attach_id)
			})
			FS.Trans.setAllTitleImageIDs(newArray);
			self.rebuildTable(adds);
		});
		$('<td/>').append($('<span/>').addClass('fs_title_tips').text('ʾ:ѡСΪ1364x67ͼƬ֧pngjpggifʽ')).appendTo($tr);
	}
}