$.extend(FR.Events, {
	CollapseOrExpand : 'collapseexpand'
});

FS.ProcessTab = FR.extend(FR.TabPane, {
	_defaultConfig : function() {
		return $.extend(FS.ProcessTab.superclass._defaultConfig.apply(this, arguments), {
			tabPosition : 'top',
			noControl : true
		});
	},
	
	_init : function() {
		FS.ProcessTab.superclass._init.apply(this, arguments);
		this.element.addClass('fs_process_tabs');
		this.expandCollapsePane();
	},
	
	//b:dolayout use fireevent
	expandCollapsePane : function() {
		var self = this;
		this.switchIcon = new FS.IconButton({
			imgsrc : 'fs_process_tabcollapse',
			switchImgsrc : 'fs_process_tabexpand',
			renderEl : $('<div/>'),
			handler : function() {
				self.fireEvent(FR.Events.CollapseOrExpand);
			}
		});
		this.tabsContent.append(this.switchIcon.element.css({
			position : 'absolute',
			top : 0,
			right : 20
		}));
	}
});

$.extend(FS.Trans, {
	saveProcess : function(process) {
		return this.ajax({
			data : {
				process : process.toJSON()
			},
			returnString : true,
			url : FR.servletURL + "?op=process_ob&cmd=save"
		});
	},
	
	removeProcess : function(name) {
		return this.ajax({
			data : {processname : name},
			url : FR.servletURL + "?op=process_ob&cmd=remove"
		});		
	},
	
	getAllProcess : function() {
		return this.ajax({
			url : FR.servletURL + "?op=process_ob&cmd=all"
		});		
	}
});

FS.ProcessEditPane = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_processedit');
		this.initNamePane();
		this.initMainPane();
		this.generatePrevent();
		this.layout();
		this.resize(config);
	},
	
	initNamePane : function() {
		//b:bar copy from auth
			var positionbar = $('<div/>').attr('id', 'fs_auth_officebar');

			var self = this;
			this.addprocess = new FS.IconButton({
				title : '',
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_addposition',
 				handler : function() {
 					FS.showPromoteDialog({
 						title : '',
						message : ':',
 						callback : function(name) {
 							self.addNewProcessDefine(name);
 						}
 					});			
 				}
 			});
 			var editprocess = new FS.IconButton({
 				title : '༭',
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_editposition',
 				handler : function() {
 					FS.showPromoteDialog({
 						title : '༭',
						message : ':',
 						value : self.getSelectedName(),
 						callback : function(name) {
 							self.setNewName(name);
 						}
 					});	
 				},
 				disabled : true
 			}), removeprocess = new FS.IconButton({
 				title : 'ɾ',
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fr_auth_removeposition',
 				handler : function() {
 					FS.showConfirmDialog({
 						
 						callback : function() {
 							self.removeSelectedProcessDefine();
 						}
 					});					
 				},
 				disabled : true
 			}), saveprocess = new FS.IconButton({
 				title : '',
 				renderEl : $('<span>&nbsp;</span>').appendTo(positionbar),
 				baseClass : 'fs_process_save',
 				handler : function() {
 					self.saveProcessDefine();					
 				},
 				disabled : true
 			});

			this.processList = new FS.BarList({
				barcontent : positionbar,
				items : [],
				width : 150,
				height : 560
			});
			
			this.processList.on(FR.Events.CLICK, function() {
				editprocess.setEnable(true);
				removeprocess.setEnable(true);
				saveprocess.setEnable(true);	
				self.setEnable(true);
				self.showProcess();
			});
//			this.processList.list.on(FR.Events.BEFORESTATECHANGE, function() {
//				var process = this.getSelectedData();
//				
//			});
			this.processList.on(FR.Events.NOSELECT, function() {
				editprocess.setEnable(false);
				removeprocess.setEnable(false);	
				saveprocess.setEnable(false);	
				self.setEnable(false);
			});
			this.processList.on(FR.Events.APPENDDATA, function(process) {
				if (!process.text) {
					process.text = process.name;
				}
			});
			this.processList.on(FR.Events.EDITDATA, function(process) {
//				FS.Trans.saveProcess(process);
//				process.text = process.name;
			});
			this.processList.on(FR.Events.REMOVEDATA, function(process) {
				var process = process.getContent();
				process.clearState();
				FS.Trans.removeProcess(process.name);
				if (FS.Process && FS.Process.refreshProcess){
					FS.Process.refreshProcess();
					FS.Process.refreshTask();
				}
			});
			
			setTimeout(function() {
				var properties = FS.Trans.getAllProcess();
				var processes = [];
				for (var i = 0, len = properties.length; i < len; i++) {
					var process = new FS.ProcessDefine(properties[i]);
					process.text = process.name;
					processes.push(process);
					FS.ProcessMananger.addProcess(process);
				}
				self.processList.popData(processes);
			}, 50);
	},
	
	getProcessPara : function(name) {
		var data = this.processList.list.options.data;
		for (var i = 0, len = data.getLength(); i < len; i++) {
			var record = data.getRecord(i);
			if (record.getShowValue() == name) {
				var ps = [], paras = record.getContent().parameters;
				for (var j = 0, jen = paras.length; j < jen; j++) {
					ps[j] = {
						text : paras[j].name,
						value : paras[j].name
					};
				}
				return ps;
			}
		}
		return null;
	},
	
	//b:ʱ򵥴
	getAllNames : function(name) {
		var alldata = this.processList.getAll();
		for (var i = 0, len = alldata.length; i < len; i++) {
			if (name == alldata[i].text) {
				alldata.remove(alldata[i]);
				break;
			}
		}
		return alldata;
	},
	
	getSelectedName : function() {
		return this.processList.getSelectedData().name;
	},
	
	generatePrevent : function() {
		this.prevent = $('<div/>').addClass('fr-window-mask').css('z-index', 10);
		this.element.append(this.prevent);
	},
	
	setEnable : function(enable) {
		if (enable) {
			this.prevent.hide();
		} else {
			this.prevent.show();
		}
	},
	
	showProcess : function() {
		var process = this.processList.getSelectedData();
		process.registerEvent();
		process.resizeContainer();
		process.paint();		
		this.mainPane.showProcess(process);
		process.fireEvent('click', process.getMouseClickOb());
	},
	
	addNewProcessDefine : function(name) {
		var process = FS.ProcessMananger.getNewProcess(name);
		this.processList.addData(process);
	},
	
	//b:ɾ
	saveProcessDefine : function() {
		var process = this.processList.getSelectedData();

		var id = FS.Trans.saveProcess(process);
		var message = "̱ɹ";
		if (!/^\d+$/.test(id)) {
			message = "̱ʧܣ";
		} else if (FS.Process && FS.Process.refreshProcess){
			FS.Process.refreshProcess();
		}
		process.id = id;
		FR.Msg.toast(message);
	},
	
	setNewName : function(name) {
		var process = this.processList.getSelectedData();
		process.text = name;
		process.setName(name);
		this.processList.list.editItem(process);
	},
	
	removeSelectedProcessDefine : function() {
		this.processList.removeSelectedData();
	},
	
	initMainPane : function() {
		this.mainPane = new FS.ProcessMainPane();
	},
	
	//b:fsָ߲죬ṹ򵥣ظ
	layout : function() {
		var pe = this.processList.element, mp = this.mainPane.element;
		pe.css({
			position : 'absolute',
			left : 10,
			top : 10
		});
		mp.css({
			position : 'absolute',
			left : 170,
			top : 10
		});
		this.prevent.css({
			position : 'absolute',
			left : 170,
			top : 10
		})
		this.element.append(pe).append(mp);
	},
	
	resize : function(rec) {
		this.element.width(rec.width).height(rec.height);
		this.processList.element.height(rec.height - 10);
		this.processList.list.element.height(rec.height - 35);
		if (rec) {
			rec.width = rec.width - 170;
			rec.height = rec.height - 10;
		} else {
			rec = {
				width : this.element.width() - 170,
				height : this.element.height()
			};
		}
		this.mainPane.resize(rec);
		this.prevent.width(rec.width).height(rec.height);
	}
});

FS.ProcessMainPane = FS.extend(FS.Widget, {
	init : function() {
		this.element = $('<div/>').attr({id : 'fs_process_mainpane'});	
		this.initProcessBasePane();	
		this.initProcessPane();
		this.initTaskPane();
		this.layout();
	},
	
	initProcessBasePane : function() {
		this.processBase = new FS.ProcessBase();
	},
	
	initProcessPane : function() {
		this.processPane = new FS.ProcessPane();
	},
	
	initTaskPane : function() {
		this.taskPane = new FS.TaskPane({
			container : this
		});
	},
	
	showProcess : function(process) {
		this.processBase.popProcess(process);
		this.processPane.popProcess(process);
		var self = this;
		this.taskPane.designer = this.processPane.designer;
		this.processPane.designer.addEvent('click', function(task) {			
			self.taskPane.popTask(task);
		});
	},
	
	getProcess : function() {
		this.processPane.getProcess();
	},
	
	//b:ѡеһtask
	initState : function() {
		
	},
	
	layout : function() {
		var be = this.processBase.element, pe = this.processPane.element, te = this.taskPane.element;
		this.absoluteLayout(be, {
			top : 0,
			left : 0,
			height : 20
		});
		this.absoluteLayout(pe, {
			top : 20,
			left : 0
		});
		this.absoluteLayout(te, {
			bottom : 0,
			left : 0,
			height : 10
		});
		this.element.append(be).append(pe).append(te);
	},
	
	absoluteLayout : function(el, config) {
		el.css($.extend({
			position : 'absolute'
		}, config));
	},
	
	resize : function(rec) {
		this.element.height(rec.height).width(rec.width);
		this.processBase.element.width(rec.width);
		this.taskPane.resize(rec);
		this.processPane.resize({
			width : rec.width,
			height : rec.height - this.processBase.element.height() - this.taskPane.element.height()
		});
		
	}
});

FS.ProcessPane = FS.extend(FS.Widget, {
	init : function() {
		this.element = $('<div/>').attr({
			id : 'fs_process_pane'
		}).mousedown(function(e) {
			//b:opera onselect 
			return false;
		});
		this.initDragBar();
		this.initDesignArea();
		this.layout();
	},
	
	initDragBar : function() {
		this.dragBar = $('<div/>').attr('id', 'fs_process_dragbar').appendTo(this.element);
		var circle = $('<div/>').attr('id', 'fs_process_dragcircle').attr('title', ':񴥷ʱ̽,༭ԡ'), 
			rect = $('<div/>').attr('id', 'fs_process_dragrect').attr('title', ':ñ߱չ,༭ԣ˫Ը'),
			subpro = $('<div/>').attr('id', 'fs_process_dragsubpro').attr('title', ':ѡΪǰ̵');
		this.dragBar.append(circle).append(rect).append(subpro);		
		this.regDrag(circle, 'endtask');
		this.regDrag(rect, 'formtask');  
		this.regDrag(subpro, 'subprotask');
		this.dragBar.attr('title', 'קͼ̣Ĭпʼʱקקק㼴½֧');
		//b:¾ todo
		circle.mousedown(function() {
			circle.addClass('fs_process_selectedtask');
			rect.removeClass('fs_process_selectedtask');
			subpro.removeClass('fs_process_selectedtask');
		});
		rect.mousedown(function() {
			circle.removeClass('fs_process_selectedtask');
			rect.addClass('fs_process_selectedtask');
			subpro.removeClass('fs_process_selectedtask');
		});
		subpro.mousedown(function() {
			circle.removeClass('fs_process_selectedtask');
			subpro.addClass('fs_process_selectedtask');
			rect.removeClass('fs_process_selectedtask');
		});
		this.showPane = $('<div/>').addClass('fs_processbar_show').appendTo(this.dragBar);
		this.initUndoButton();
	},
	
	initUndoButton : function() {
		var self = this;
		this.undo = new FS.IconButton({
			title : '',
 			renderEl : $('<div/>'),
 			width : 24,
 			height : 24,
 			baseClass : 'fs_process_undo',
 			disabled : true,
 			handler : function() {
 				self.designer.undo();
 			}
 		});
 		this.redo = new FS.IconButton({
			title : 'ָ',
 			renderEl : $('<div/>'),
 			width : 24,
 			height : 24,
 			disabled : true,
 			baseClass : 'fs_process_redo',
 			handler : function() {
 				self.designer.redo();
 			}
 		});
 		this.dragBar.append($('<div/>').addClass('fs_processbar_tools').append(this.undo.element).append(this.redo.element));
	},
	
	regDrag : function(el, type) {
		if (!el) {
			return;
		}
		el.draggable({
			containment : this.element,
			helper : 'clone',
			revert: "invalid"
		});
	},
	
	initDesignArea : function() {
		this.designArea = $('<div/>').attr('id', 'fs_process_designArea').appendTo(this.element);
		var outcan = this.createCanvasContent(6, "fs_processdesign_state");
		this.designArea.append(this.createCanvasContent(1, "fs_processdesign_shape"))
			.append(this.createCanvasContent(2, "fs_processdesign_transition"))
			.append(this.createCanvasContent(3, "fs_processdesign_name"))
			.append(this.createCanvasContent(4, "fs_processdesign_cell"))
			.append(this.createCanvasContent(5, "fs_processdesign_over"))
			.append(outcan);
		var self = this;
		outcan.droppable({
			drop : function(e, ui) {
				$('.ui-draggable-dragging', self.dragBar).remove();
				if (!self.designer) {
					return;
				}
				var type = 'endtask';
				var id = ui.draggable.attr('id');
				if (id.indexOf('rect') > 0) {
					type = 'formtask';
				} else if (id.indexOf('sub') > 0) {
					type = 'subprotask';
				}
				self.designer.addNewTask(FS.getPosition(e), type);
			}
		});
	},
	
	createCanvasContent : function(zdx, id) {
		return $('<div/>').css({
			position : 'absolute',
			left : 0,
			top : 0,
			height : 600,
			width : 800,
			'z-index' : zdx
		}).append($('<canvas/>').attr('id', id).attr({
			height : 600,
			width : 800
		}));
	},
	
	expandOrCollapseDesigner : function(height) {
		this.element.height(height);
		this.designArea.height(height);
		this.dragBar.height(height);
	},
	
	layout : function() {
		this.absoluteLayout(this.dragBar, {
			top : 0,
			left : 0,
			height : 30
		});
		this.absoluteLayout(this.designArea, {
			top : 30,
			left : 0
		});
	},
	
	absoluteLayout : function(el, config) {
		el.css($.extend({
			position : 'absolute'
		}, config));
	},
	
	resize : function(rec) {
		this.element.width(rec.width).height(rec.height);
		this.dragBar.width(rec.width);
		this.designArea.height(rec.height - 30);
		this.designArea.width(rec.width);
	},
	
	popProcess : function(process) {
		this.designer = process;
		var self = this;
		this.undo.setEnable(this.designer.canUndo());
		this.redo.setEnable(this.designer.canRedo());
		this.designer.addNoRepeatEvent(FS.Events.UNDO, function() {
			self.undo.setEnable(this.canUndo());
			self.redo.setEnable(this.canRedo());
		});
		this.designer.addNoRepeatEvent(FS.Events.PROCESSSTARTSAVE, function() {
			self.showStartSave();
		});
		this.designer.addNoRepeatEvent(FS.Events.PROCESSSAVEFINISH, function() {
			self.showSaveFinish();
		});			
	},
	
	//b:interval
	showStartSave : function() {
		this.showPane.text('.');
	},
	
	showSaveFinish : function() {
		this.showPane.text('.');
	},
	
	getProcess : function() {
		return this.designer ? this.designer.getProcess() : null;
	}
});

FS.ProcessBase = FS.extend(FS.Widget, {
	limitParaLength : 3,
	
	init : function() {
		this.element = $('<div/>').attr('id', 'fs_process_base').height(20);
		this.initPane();
	},
	
	initPane : function() {
		var self = this;
		this.paraPane = $('<div/>').addClass('fs_process_basepara').append($('<span/>').text(':')).append(this.createAddParaText());
		
		this.triText = $('<span/>').addClass('fs_process_basetext').text('ֶ').click(function(e) {
			self.generateTriggerPane();
		});
		this.triPane = $('<div/>').addClass('fs_process_basetrigger').append($('<span/>').text(':')).append(this.triText);
		this.element.append(this.paraPane).append(this.triPane);
	},
	
	popProcess : function(process) {
		this.process = process;
		this.checkParameters4Base();
		this.checkTrigger4Base();
	},
	
	checkParameters4Base : function() {
		$($('span', this.paraPane)[0]).siblings().remove();
		var paras = this.process.parameters;
		if (this.process && paras && paras.length > 0) {
			var len = Math.min(this.limitParaLength, paras.length);
			for (var i = 0; i < len; i++) {
				this.paraPane.append(this.createParaText(paras[i].name));				
			}
			if (paras.length > len) {
				this.paraPane.append(this.createParaText("..."));
			}
		}
		this.paraPane.append(this.createAddParaText());
	},
	
	createAddParaText : function() {
		return this.createParaText('').css('margin-left', 12);
	},
	
	//b:removeʱպϰܲͷ
	createParaText : function(text) {
		var self = this;
		return $('<span/>').addClass('fs_process_basetext').text(text).click(function() {
			self.generateParametersPane();
		});
	},
	
	checkTrigger4Base : function() {
		var text = 'ֶ';
		if (this.process && this.process.trigger) {
			text = 'Զ';
		}
		this.triText.text(text);
	},
	
	generateParametersPane : function() {
		//if (!this.parametersPane) {
			this.parametersPane = new FS.ParametersPane({});
			var self = this;
			function confire() {
				self.process.itemChanged = self.parametersPane.parasTable.itemChanged;
				self.process.setParameters(self.parametersPane.getParameters());
				if(self.parametersPane.isShareProcessName()) {
					var shareProcessName = self.parametersPane.getShareProcessName();
					self.process.setShareProcessName(shareProcessName);
					var shareProcess = FS.ProcessMananger.getProcessByName(shareProcessName);
					if(shareProcess) {
						self.process.setProperty('parameters', shareProcess.getParameters());
					}	
				} else {
					self.process.setShareProcessName('');
				}
				self.checkParameters4Base();
			}
			this.paraDialog = new FS.Dialog({
				title : '',
				content : this.parametersPane.element,
				confire : confire,
				height : 360,
				width : 500
			});
		//}
		if (this.process) {
			this.parametersPane.popParameters(this.process.parameters);
			this.parametersPane.popShareProcessName(this.process.shareProcessName);
			this.process.setProperty('originalShareProcessName', this.parametersPane.getShareProcessName());
		}
		this.paraDialog.setVisible(true);
	},
	
	generateTriggerPane : function() {
		if (!this.triggerPane) {
			this.triggerPane = new FS.TriggerPane({
				
			});
			var self = this;
			function confire() {
				self.process.setTrigger(self.triggerPane.getTrigger());
				self.checkTrigger4Base();
			}
			this.triggerDialog = new FS.Dialog({
				title : '񴥷ʱ',
				content : this.triggerPane.element,
				confire : confire,
				height : 560,
				width : 520
			});
		}
		
		if (this.process) {
			this.triggerPane.popTrigger(this.process.trigger);
		}
		this.triggerDialog.setVisible(true);
	}
});

//b: reportwidgetظȡΪؼ
FS.ParametersPane = FS.extend(FS.Widget, {
	init : function() {
		this.element = $('<div/>').addClass('fs_process_addpara');
		this.initPane();
	},
	
	initPane : function() {
		this.paraChanged = false;
		var bar = $('<div/>').attr('id', 'fs_reportadd_opbar'), self = this;
		var parasTable;
		var self = this;
		var addPara = new FR.IconButton({
				text : 'Ӳ',
				renderEl : $('<span>&nbsp;</span>'),
				baseClass : 'fs_reportadd_addpara',
				height : 21,
				width : 21,
				handler : function() {
					parasTable.uiAddData();
				}
		}), editPara = new FR.IconButton({
				text : '༭',
				renderEl : $('<span>&nbsp;</span>'),
				baseClass : 'fs_reportadd_editpara',
				disabled : true,
				height : 21,
				width : 21,
				handler : function() {
					parasTable.uiEditData();
				}
		}), removePara = new FR.IconButton({
				text : 'Ƴ',
				renderEl : $('<span>&nbsp;</span>'),
				height : 21,
				width : 21,
				baseClass : 'fs_reportadd_removepara',
				disabled : true,
				handler : function() {
					parasTable.uiRemoveData();
				}
		});
		this.refreshPara = new FR.IconButton({
				text : '',
				renderEl : $('<span>&nbsp;</span>'),
				baseClass : 'fs_reportadd_loadpara',
				disabled : true,
				height : 21,
				width : 21,
				handler : function() {
					parasTable.popData(FS.Trans.getReportParas(self.path.getValue()));
				}
		});
		bar.append(addPara.element).append(editPara.element).append(removePara.element).append(this.refreshPara.element);
		parasTable = this.parasTable = new FS.Grid({
				cls : 'fs_reportadd_parasTable',
				title : ':',
				selfbar : bar,
				pagecount : 5,
				columnsconfig : [{
					text : 'name',
					showValue : '',
					width : 105,
					sort : false,
					widget : {type : 'text', allowBlank : false, errorMsg :  'Ϊգ'}
				}, {
					text : 'type',
					showValue : '',
					width : 105,
					widget : {type : 'combo', items : [{text:'ַ', value : 'String'},
														 {text:'', value : 'Double'},
														 {text:'Long', value : 'Long'},
														  {text:'', value : 'Date'}, 
														  {text:'', value : 'Boolean'}, 
														  {text:'ʽ', value : 'Formula'}], allowBlank : false, errorMsg :  'ͲΪգ'}
				}, {
					text : 'value',
					showValue : 'ֵ',
					width : 105,
					widget : {type : 'text', allowBlank : false, errorMsg :  'ֵΪգ'}
				}, {
					text : 'autoInc',
					showValue : '',
					width : 105,
					widget : {type : 'checkbox'}
				}],
				items : []
		});
		parasTable.itemChanged = false;
		parasTable.loading(true);
		parasTable.on(FS.Events.SELECTDATA, function() {
				editPara.setEnable(true);
				removePara.setEnable(true);
		});
			
		parasTable.on(FS.Events.NOSELECT, function() {
				editPara.setEnable(false);
				removePara.setEnable(false);
		});
		this.createShareProcessDiv();
		this.element.append(parasTable.element);
	},
	
	createShareProcessDiv : function() {
		var self = this;
		var shareParaDiv = $('<div/>').addClass('fs_para_shareprocess');
		var paraCheckBoxDiv = ($('<div/>')).addClass('fs_shareprocesscontainer').appendTo(shareParaDiv);
		var paraComboBoxDiv = ($('<div/>')).addClass('fs_shareprocesscontainer').appendTo(shareParaDiv);
		var items = FS.Design.processPane.getAllNames(FS.Design.processPane.getSelectedName());
		this.processComboBox = new FR.ComboBoxEditor({
			renderEl : paraComboBoxDiv,
			items : items,
			disabled : true
		});
		this.shareParaCheckBox = new FR.CheckBox({
			renderEl : paraCheckBoxDiv,
			text : ':',
			value : false,
			width : 150
		});
		
		this.processComboBox.on(FR.Events.AFTEREDIT, function() {
			self.parasTable.itemChanged = true;	
		});
		this.shareParaCheckBox.on(FR.Events.STATECHANGE, function() {
            self.parasTable.itemChanged = true;
            var isSharePara = self.shareParaCheckBox.isSelected();
            if (isSharePara) {
             	self.processComboBox.enable();
            } else{
            	self.processComboBox.disable();
            }
        });
		this.element.append(shareParaDiv);
	},
	
	popParameters : function(parameters) {
		this.parasTable.popData(parameters);
	},
	
	popShareProcessName : function(shareProcessName) {
		this.processComboBox.setValue(shareProcessName);
		if(shareProcessName) {
			this.shareParaCheckBox.setValue(true);
		}
	},
	
	getParameters : function() {
		return this.parasTable.options.items;
	},
	
	getShareProcessName : function() {
		return this.processComboBox.getValue();
	},
	
	isShareProcessName : function() {
		return this.shareParaCheckBox.getValue();
	}
});

//b:ʱǱtriggerý棬Ҫͳһtodo
FS.TriggerPane = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').addClass('fs_process_trigger').css('margin', '0 12px');
		this.createPane();
	},
	
	popTrigger : function(trigger) {
		if (!trigger) {
			this.usetrigger.attr('checked', false);
			return;
		}
		this.setEnable(true);
		this.usetrigger.attr('checked', true);
		if (trigger.startType == 2) {
			$('#on', this.element).attr('checked', true);
			this.startTime.setValue(trigger.startTime);
		} else if (trigger.startType == 1) {
			$('#immediately', this.element).attr('checked', true);
		}
		if(trigger.recurrenceType == "once"){
			this.onceRadio.triggerHandler('click');
			this.onceRadio.attr('checked', true);
		} else if(trigger.recurrenceType == "simple"){
			this.simpleRadio.triggerHandler('click');
			this.simpleRadio.attr('checked', true);
			$('#recurrenceInterval', this.simplePane).val(trigger.recurrenceInterval);
			this.frequenceCombo.setValue(trigger.recurrenceIntervalUnit);
			if (trigger.repeatCount == -1) {
				$('#indifinitely', this.simplePane).attr('checked',true);
				$('#repeatCount', this.simplePane).val("");
				this.untiltime.setValue("");
			} else if (trigger.endTime) {
				$('#until', this.simplePane).attr('checked',true);
				$('#repeatCount', this.simplePane).val("");
				this.untiltime.setValue(trigger.endTime);
			} else if (trigger.repeatCount > -1) {
				$('#repeat', this.simplePane).attr('checked',true);
				$('#repeatCount', this.simplePane).val(trigger.repeatCount);
				this.untiltime.setValue("");
			}
		} else if(trigger.recurrenceType == "calendar"){
			this.calendarRadio.triggerHandler('click');
			this.calendarRadio.attr('checked', true);
			$('#minutes', this.calendarPane).val(trigger.minutes);
			$('#hours', this.calendarPane).val(trigger.hours);
			if(!trigger.dayType || trigger.dayType == 1){
				$('#everyday', this.calendarPane).attr('checked',true);
				for(var i = 0; i < this.weekdays.length; i++){
					this.weekdays[i][0].checked = false;
				}
				$('#monthdays', this.calendarPane).val("");
			} else if(trigger.dayType == 2){
					$('#weekday', this.calendarPane).attr('checked',true);
					weekdaystable.show();
					var checkeddays = trigger.weekDays.split(",");
					for(var j = 0; j < checkeddays.length; j++){
						for(var i = 0; i < this.weekdays.length; i++){
							if(checkeddays[j] == i+1){
								this.weekdays[i][0].checked = true;
								break;
							}
						}
					}
					$('#monthdays', this.calendarPane).val("");
				} else if(trigger.dayType == 3){
					$('#monthday', this.calendarPane).attr('checked',true);
					for(var i = 0; i < this.weekdays.length; i++){
						this.weekdays[i][0].checked = false;
					}
					$('#monthdays', this.calendarPane).val(trigger.monthDays);
				}
				if (trigger.months) {
					var checkedmonths = trigger.months.split(",");
					this.allmonths[0].checked = (checkedmonths.length == this.months.length);
					for(var j = 0; j< checkedmonths.length; j++){
						for(var i = 0; i < this.months.length; i++){
							if(checkedmonths[j] == i + 1){
								this.months[i][0].checked = true;
								break;
							}
						}
					}
				} else {
					this.allmonths[0].checked = false;
					for(var i = 0; i < this.months.length; i++){
						this.months[i][0].checked = false;
					}
				}
	
				if (iTrigger.endTime) {
					this.endtime.setValue(iTrigger.endTime);
				} else {
					$('#indifi', this.calendarPane).attr('checked',true);
					this.endtime.setValue("");
				}
		}
	},
	
	getTrigger : function() {
		if (!this.usetrigger[0].checked) {
			return;
		}
		if (!this.checkValue()) {
			return;
		}
		var trigger = {};
		if ($('#on', this.element).attr('checked')) {
			trigger.startType = 2;
			trigger.startTime = this.startTime.getValue();
		} else {
			trigger.startType = 1;
		}
		if ($('#once', this.element).attr('checked')) {
			trigger.recurrenceType = 'once';
		} else if ($('#simple', this.element).attr('checked')) {
			trigger.recurrenceType = 'simple';
			trigger.recurrenceInterval = $('#recurrenceInterval', this.simplePane).val();
			trigger.recurrenceIntervalUnit = this.frequenceCombo.getValue();

			if ($('#indifinitely', this.simplePane).attr('checked')) {
				trigger.repeatCount == -1;
			} else if ($('#until', this.simplePane).attr('checked')) {
				trigger.endTime = this.untiltime.getValue();
			} else if ($('#repeat', this.simplePane).attr('checked')) {
				trigger.repeatCount = $('#repeatCount', this.simplePane).val();
			}
		} else if ($('#carlendar', this.element).attr('checked')) {
			trigger.recurrenceType = 'calendar';
			trigger.minutes = $('#minutes', this.calendarPane).val();
			trigger.hours = $('#hours', this.calendarPane).val();
			if($('#everyday', this.calendarPane).attr('checked')){
				trigger.dayType == 1;
			} else if($('#weekday', this.calendarPane).attr('checked')){
				trigger.dayType == 2;
				var checkeddays = [];
				for(var i = 0; i < this.weekdays.length; i++){
					if(this.weekdays[i][0].checked){
						checkeddays.push(i+1);
					}
				}
				trigger.weekDays = checkeddays.toString();
			} else if($('#monthday', this.calendarPane).attr('checked')){
				trigger.dayType == 3
			}
			var checkedmonths = [];
			for(var i = 0; i < this.months.length; i++){
				if(this.months[i][0].checked){
					checkedmonths.push(i+1);
				}
			}
			trigger.months = checkedmonths.toString();
	
			trigger.endTime = $('#indifi', this.calendarPane).attr('checked') ? "" : this.endtime.getValue();
		}
		return trigger;
	},
	
	checkValue : function() {
		if (!$('#on', this.element).attr('checked') && !$('#immediately', this.element).attr('checked')) {
			return;	
		}
		if (!$('#once', this.element).attr('checked') && !$('#simple', this.element).attr('checked') && !$('#carlendar', this.element).attr('checked')) {
			return;
		}
		return true;
	},
	
	generatePrevent : function() {
		this.prevent = $('<div/>').addClass('fr-window-mask').css('z-index', 10).css({
			position : 'absolute',
			top : 20,
			width : 520,
			height : 480
		});
		this.element.append(this.prevent);
	},
	
	setEnable : function(enable) {
		if (enable) {
			this.prevent.hide();
		} else {
			this.prevent.show();
		}
	},
	
	createPane : function() {
		var self = this;
		this.generatePrevent();
		this.usetrigger = $('<input type="checkbox" id="usetrigger">').click(function(e) {
			if (this.checked) {
				self.setEnable(true);
			} else {
				self.setEnable(false);
			}
		});
		
		$('<div/>').append(this.usetrigger).append($('<span/>').text('ʹöʱ')).appendTo(this.element);
		this.startTime = new FR.DateTimeEditor(this.timeConfig());
		this.element.append($('<table/>').append($('<tr><td><p>ʼʱ趨</p></td></tr></table>'))
			.append($('<tr><td><input type="radio" name="start" value=1 id="immediately"/>ɺ̿ʼ</td></tr>'))
			.append($('<tr><td><input type="radio" name="start" value=2 id="on"/>趨ʼʱ䣺</td></tr>').append($('<td/>').append(this.startTime.element))));
		$('<p>ע⣺ִƵеִֻһκͼظִʼʱͻִУԶظִʼִС</p>').appendTo(this.element);
		var recurrenceType = $('<p class="frequentTitle">ִƵʣ</p>').appendTo(this.element);
		var recurrenceRadios = $('<div/>').appendTo(this.element);
		var recurrencePane = $('<div></div>').appendTo(this.element);

		var oncePane = this.createOncePane();
		oncePane.appendTo(recurrencePane).hide();
		var simplePane = this.createSimplePane();
		simplePane.appendTo(recurrencePane).hide();
		var calendarPane = this.createCalendarPane();
		calendarPane.appendTo(recurrencePane).hide();
		
		this.onceRadio = $('<input type="radio" name="recurrenceType" value="once" id="once">')
		.click(function(){
			oncePane.show();
			simplePane.hide();
			calendarPane.hide();
		}).appendTo(recurrenceRadios);
		
		$('<span title="ʼִֻһ" style="padding-right:5px">ִֻһ</span>').appendTo(recurrenceRadios);
		this.simpleRadio = $('<input type="radio" name="recurrenceType" value="simple" id="simple">')
		.click(function(){
			oncePane.hide();
			simplePane.show();
			calendarPane.hide();
		}).appendTo(recurrenceRadios);
		$('<span title="ʱձܱ" style="padding-right:5px">ظִ</span>').appendTo(recurrenceRadios);
		this.calendarRadio = $('<input type="radio" name="recurrenceType" value="calendar" id="calendar">')
		.click(function(){
			oncePane.hide();
			simplePane.hide();
			calendarPane.show();
		}).appendTo(recurrenceRadios);
		$('<span title="Ƶ趨" style="padding-right:5px">Զظִ</span>').appendTo(recurrenceRadios);	
		
	},
	
	createOncePane : function() {
		var oncePane = this.oncePane = $("<div><p class='frequentTitle'>ʱ趨</p></div>");
		$("<div><input type='checkbox' checked disabled></input>ִһκ󼴽</div>").appendTo(oncePane);
		return oncePane;
	},
	
	createSimplePane : function() {
			var simplePane = this.simplePane = $("<div/>");		
			var frequencetable = $('<table/>').appendTo(simplePane);
			var frequencetr = $('<tr><td><p>ִƵʣÿ<input id="recurrenceInterval"/></p></td></tr>').appendTo(frequencetable);
			this.frequenceCombo = new FR.ComboBoxEditor({
				directEdit : true,
				allowBlank : false,
				width: 70,
				items: [{value: 1, text: ""},
						{value: 2, text: "Сʱ"},
						{value: 3, text: ""},
						{value: 4, text: ""}]
			});
			$('<td/>').append(this.frequenceCombo.element).appendTo(frequencetr);
			var occurtable = $('<table></table>').appendTo(simplePane);
			$('<tr><td><p class="frequentTitle">ʱ趨</p></td></tr>').appendTo(occurtable);
			var indifinitely = $('<tr><td><input type="radio" name="occur" value="indifinitely" id="indifinitely"/></td><td></td></tr>').appendTo(occurtable);
			var until =  $('<tr><td><input type="radio" name="occur" value="until" id="until"/>ʱ䣺</td></tr>').appendTo(occurtable);
			this.untiltime = new FR.DateTimeEditor(this.timeConfig());
			($('<td/>').append(this.untiltime.element)).appendTo(until);
			$('<tr><td><input type="radio" name="occur" value="repeat" id="repeat"/>ظִд</td><td><input id="repeatCount"/></td></tr>').appendTo(occurtable);			
			return simplePane;		
	},
	
	createCalendarPane : function() {
		var self = this;
		var calendarPane = this.calendarPane = $("<div/>");
		var timeTable = $('<table/>').appendTo(calendarPane);
		var mh = $('<tr><td><p>ʱã</p></td><td><div><input id="hours"/>(ʱ)</div></td><td><div><input id="minutes"/>()</div></td></tr>').appendTo(timeTable);
		var daystable = $('<table/>').appendTo(calendarPane);
		var dayCheckBox = $('<input type="radio" name="days" value=1 id="everyday"/>').click(function() {
			if (this.checked) {
				weekdaystable.hide();
			}
		});
			
		var everyday = $('<tr><td>죺</td></tr>').append($('<td/>').append(dayCheckBox)).append('<td>ÿ</td>').appendTo(daystable);
			
			
		var weekdaystr1 = $('<tr><td></td></tr>').appendTo(daystable);
		var weekdayCheckBox = $('<input type="radio" name="days" value=2 id="weekday"/>')
			.click(function() {
				if (this.checked) {
					weekdaystable.show();
				}
			});
		weekdaystr1.append($('<td valign="top"></td>').append(weekdayCheckBox));
		var weekdaystable = $('<table><tr><td>һ</td><td>ܶ</td><td></td><td></td><td></td><td></td><td></td></tr></table>');
		weekdaystable.wrap($('<td>ÿܵ</td>')).parent().appendTo(weekdaystr1);
		var weekdaystr2 = $('<tr></tr>').appendTo(weekdaystable);
		this.weekdays = new Array(7);
		for(var i=0; i < this.weekdays.length; i++){
			this.weekdays[i] = $('<input type="checkbox"/>');
			this.weekdays[i].wrap($('<td></td>')).parent().appendTo(weekdaystr2);
		}
		weekdaystable.hide();
			
		var monthCheckBox = $('<input type="radio" name="days" value=3 id="monthday"/>').click(function() {
			if (this.checked) {
				weekdaystable.hide();
			}
		});
		var monthdays = $('<tr><td></td></tr>').append($('<td/>').append(monthCheckBox)).append($('<td>ÿµ<input id="monthdays"/></td>')).appendTo(daystable);		
		var monthstable = $('<table></table>').appendTo(calendarPane);
		var allmonthstr = $('<tr><td>£</td></tr>').appendTo(monthstable);
		this.allmonths = $('<input class="test" type="checkbox"/>')
			.click(function(){
				if(this.checked){
					for(var i = 0; i < self.months.length; i++){
						self.months[i][0].checked = true;
					}
				}
			});

			$('<td></td>').append(this.allmonths).appendTo(allmonthstr);
			$('<td></td>').appendTo(allmonthstr);
			var monthsnametr = $('<tr><td></td><td>һ</td><td></td><td></td><td></td><td></td><td></td>' +
					'<td></td><td></td><td></td><td>ʮ</td><td>ʮһ</td><td>ʮ</td></tr>').appendTo(monthstable);
			var monthstr = $('<tr><td></td></tr>').appendTo(monthstable);
			this.months = new Array(12);
			for(var i = 0; i < this.months.length; i++){
				this.months[i] = $('<input type="checkbox"/>')
				.click(function(){
					if(!this.checked){
						self.allmonths[0].checked = false;
					}
				});
				this.months[i].wrap($('<td></td>')).parent().appendTo(monthstr);
			}
			
			var endtimeTable = $('<table></table>').appendTo(calendarPane);
			$('<tr><td><p class="frequentTitle">ʱ趨</p></td></tr>').appendTo(endtimeTable);
			var indifinitely = $('<tr><td><input type="radio" name="occurcalendar" value="indifi" id="indifi"/></td><td></td></tr>').appendTo(endtimeTable);
			var endtimeTR = $('<tr><td><input type="radio" name="occurcalendar" value="endtimeRadio" id="endtimeRadio"/>ʱ䣺</td></tr>').appendTo(endtimeTable);
			var endtimediv = $('<div></div>').wrap($('<td></td>')).parent().appendTo(endtimeTR);
			this.endtime = new FR.DateTimeEditor(this.timeConfig());
			$('<td/>').append(this.endtime.element).appendTo(endtimeTR);
			return calendarPane;
	},
	
	timeConfig : function() {
		return {
			width : 180,
			disable : false,
			directEdit : true,
			format : "yyyy-MM-dd HH:mm:ss"
		};
	}
});

FS.NameReportChoose = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').addClass('fs_namereport');
		this.generateShowName(config);
		this.generateReportBlock(config);
	},
	
	generateShowName : function(config) {
		this.table = $('<table/>').attr({id : 'fs_reportadd_table', cellSpacing : 8}).appendTo(this.element);
		this.tbody = $('<tbody/>').appendTo(this.table);
		this.name = new FS.TextEditor({
			width : 120,
			height : 24
		});
		if (config.changeName) {
			this.name.on(FR.Events.AFTEREDIT, function() {
				config.changeName(this.getValue());
			});			
		}
		$('<tr/>').append($('<td/>').text((config.nameText ? config.nameText : "") + ":")).append($('<td/>').width(150).append(this.name.element)).append($('<td/>').width(60)).appendTo(this.tbody);
	},
	
	
	generateReportBlock : function(config) {
		this.path = new FS.TextEditor({
			width : 150,
			height : 24,
			readonly : true
		});
		
		if (config.changeReport) {
			this.path.on(FR.Events.CHANGE, function(value, oldvalue) {
				if (value && value != oldvalue) {
					config.changeReport(value);
				}			
			});
		}
		var self = this;
		var viewButton = new FS.Button({
			text : '',
			width : 60,
			height : 20,
			handler : function() {
				self.chooseReport(self.path.getValue());
			}
		});
		$('<tr/>').append($('<td/>').text((config.reportName ? config.reportName : "· ") + ":")).append($('<td/>').append(this.path.element)).append($('<td/>').append(viewButton.element)).appendTo(this.tbody);
		this.treeTR = $('<tr/>').height(90).append($('<td/>')).append($('<td/>').attr('colSpan', 2)).append($('<td/>')).hide().appendTo(this.tbody);
	},
	
	hidePath : function() {
		this.path.element.parent().parent().hide();
	},
	
	showPath : function() {
		this.path.element.parent().parent().show();
	},
	
	chooseReport : function(path) {
		if (this.treeTR.is(':visible')) {
			this.treeTR.hide();
			return;
		}
		if (!this.treecontent) {
			this.treecontent = $('<div/>').addClass('fs_reportadd_tree').appendTo($('td:eq(1)', this.treeTR));
			this.treeTR.css('display', 'table-row');
			this.createReportsTree();
		}
		this.treeTR.css('display', 'table-row');
		this.treeTR.show();
	},
	
	//b:tree fontĵheightҪı
	createReportsTree : function() {
		var self = this;
		this.reportsTree = new FS.Tree({
			height : 90,
			width : 220,
			renderEl : this.treecontent,
			expand : false,
			widgetUrl : FR.servletURL + "?op=fs_entry&cmd=getreports&form=true&file=frm"
		});
		this.reportsTree.on(FR.Events.CLICK, function() {
			self.path.setValue(this.getSelectedData().getContent().path);
		});
	},
	
	setName : function(name) {
		this.name.setValue(name);
	},
	
	setReport : function(report) {
		this.path.setValue(report);
	},
	
	getName : function() {
		return this.name.getValue();
	},
	
	getReport : function() {
		return this.path.getValue();
	}
});

FS.TaskBasic = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_process_designtask');
		this.initPane();
	},
	
	initPane : function() {
		this.nameReportPart();
		this.joinmodePart();
//		this.taskTagPane();
		this.processNamePane();
	},
	
	nameReportPart : function() {
		this.namereport = new FS.NameReportChoose({
			nameText : '',
			reportText : 'ģ',
			changeName : function(name) {
				if (this.task) {
					this.task.setName(name);
					this.task.processDefine.repaint();
				}				
			}.createDelegate(this),
			changeReport : function(report) {
				if (this.task) {
					this.task.setForm(report);
				}
			}.createDelegate(this)
		});
		this.namereport.element.addClass('fs_process_tasknamereport');
		this.element.append(this.namereport.element);
	},
	
	joinmodePart : function() {
		this.joinContent = $('<div/>').addClass('fs_process_taskjoin');
		$('<span/>').text(":").appendTo(this.joinContent);
		this.radioOne = this.createRadio();
		this.radioOne.click(function(e) {
			if (this.task) {
				this.task.setJoinMode(1);
			}
			e.stopPropagation();
		}.createDelegate(this));
		this.radioAll = this.createRadio().click(function(e) {
			if (this.task) {
				this.task.setJoinMode(2);
			}
			e.stopPropagation();
		}.createDelegate(this));
		$('<div/>').css('cursor', 'pointer').append(this.radioOne).append($('<span/>').addClass('fs_process_taskonejoin').text('һ֧')).click(function() {
			this.radioOne.click();
		}.createDelegate(this)).appendTo(this.joinContent);
		$('<div/>').css('cursor', 'pointer').append(this.radioAll).append($('<span/>').addClass('fs_process_taskalljoin').text('з֧')).click(function() {
			this.radioAll.click();
		}.createDelegate(this)).appendTo(this.joinContent);
		this.element.append(this.joinContent);
	},
	
	createRadio : function() {
		var self = this;
		var radio =  $('<input/>').attr({
			type : 'radio',
			checked : false,
			name : 'joinmode'
		});
		return radio;
	},
	
	taskTagPane : function() {
		this.tagpane = $('<div/>').addClass('fs_process_tagpane');

		this.multicombo = new FS.MulCombo({
			width : 120,
			height : 24,
			items : [],
			directEdit : true,
			delimiter : ','
		});
		var self = this;
		this.multicombo.on(FR.Events.CLICK,  function() {
			this.reBuild(self.getProcessPara());
		});
		this.multicombo.on(FR.Events.AFTEREDIT, function() {
			self.task.setParameters(this.getValue());
		});
		this.tagpane.append($('<span/>').text('ѡǩ:')).append(this.	multicombo.element).appendTo(this.element);
		
	},
	
	processNamePane : function() {
		this.processComboPane = $('<div/>').addClass('fs_process_processcombo').append($('<span/>').text('ѡ:'));
		this.processcombo = new FS.Combobox({
			width : 120,
			height : 24,
			items : [],
			directEdit : true
		});
		this.processcombo.element.css({
			position : 'absolute',
			top : 0,
			left : 60
		});
		var self = this;
		this.processcombo.on(FR.Events.CLICK,  function() {
			this.reBuild(self.getProcessNames());
		});
		this.processcombo.on(FR.Events.AFTEREDIT, function() {
			self.task.setSubName(this.getValue());
		});
		this.processComboPane.hide().append(this.processcombo.element).appendTo(this.element);
	},
	
	getProcessNames : function() {
		return FS.Design.processPane.getAllNames(this.task.processDefine.getName());
	},
	
	getProcessPara : function() {
		if (!this.task) {
			return;
		}
		var paras = this.task.processDefine.parameters;
		paras = paras ? paras : [];
		var data = [];
		for (var i = 0, len = paras.length; i < len; i++) {
			data[i] = {
				text : paras[i].name,
				value : paras[i].name
			};
		}
		return data;
	},
	
	popTask : function(task) {
		this.task = task;
		var type = task.getType();
		if (type == "formtask") {
			this.namereport.showPath();
//			this.tagpane.show();
			this.setReport(task.form);
//			this.setTags(task.parameters);
		} else {
			this.namereport.hidePath();
//			this.tagpane.hide();
		}
		if (type == "starttask" || type == "subprotask") {
			this.joinContent.hide();
		} else {
			this.joinContent.show();
			this.setJoinMode(task.joinMode);
		}
		if (type == "subprotask") {
			this.processComboPane.show();
			this.setSubProcessName(task.subname);
		} else {
			this.processComboPane.hide();
		}
		this.setName(task.name);
	},
	
	setSubProcessName : function(subname) {
		this.processcombo._setValue(subname);
	},
	
	setTags : function(parameters) {
		if (parameters == null) {
			parameters = "";
		}
		parameters = parameters.split(",");
		if (parameters[parameters.length - 1] == "") {
			parameters.pop();
		}
		this.multicombo._setValue(parameters);
	},
	
	setName : function(name) {
		this.namereport.setName(name);
	},
	
	getName : function() {
		this.namereport.getName();
	},
	
	setReport : function(path) {
		this.namereport.setReport(path);
	},
	
	getReport : function() {
		this.namreport.getReport();
	},
	
	setJoinMode : function(mode) {
		if (mode == 1) {
			this.radioOne.attr('checked', true);
		} else {
			this.radioAll.attr('checked', true);
		}
	},
	
	getJoinMode : function() {
		return this.radioAll.attr('checked') ? 2 : 1;
	},
	
	hideJoinMode : function() {
		this.joinContent.hide();
	},
	
	hideReport : function() {
		this.namereport.element.hide();
	},
	
	hide : function() {
		this.element.hide();
	}
});

FS.TaskUser = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_process_taskuser');
		this.generateUserPane();	
	},
	
	generateUserPane : function() {
		$('<div/>').addClass('fs_process_taskuserexplain').text('ΪǰѡִԱ:').appendTo(this.element);
		
		this.mainpane = $('<div/>').addClass('fs_process_taskuserpane');
		var self = this;
		this.starter = this.createRadio().click(function(e){
			self.button.setEnable(false);
			self.datas.setEnable(false);
			self.formulaText.setEnable(false);
			self.rolesTable.clearContent();
			if (self.task) {
				self.task.setUsers({
					type : 'parameterusers',
					paraname : 'processStarter'
				});
			}

			e.stopPropagation();
		});	
		this.formula = this.createRadio().click(function(e){
			self.button.setEnable(false);
			self.datas.setEnable(false);
			self.formulaText.setEnable(true);
			self.rolesTable.clearContent();
			if (self.task) {
				self.task.setUsers({
					type : 'formulausers'
				});
			}
			e.stopPropagation();
		});	
		this.processpara = this.createRadio().click(function(e){
			self.button.setEnable(false);
			self.datas.setEnable(true);
			self.formulaText.setEnable(false);
			self.rolesTable.clearContent();
			if (self.task) {
				self.task.setUsers({
					type : 'parameterusers'
				});
			}
			e.stopPropagation();			
		});	
		this.roles = this.createRadio().click(function(e){
			self.button.setEnable(true);
			self.datas.setEnable(false);
			self.formulaText.setEnable(false);
			if (self.task) {
				self.task.setUsers({
					type : 'roleusers'
				});
			}
			e.stopPropagation();
		});	
		this.rolesTable = new FS.ButtonsTable({
			width : 320,
			height : 120,
			container : this
		});
		var self = this;
		var button = this.button = new FS.Button({
			text : 'Ԥ',
			height : 20,
			disabled : true,
			handler : function() {
				self.showRolesDialog(self.rolesTable.getUsers());
			}
		});
		var datas = this.datas = new FS.Combobox({
			width : 120,
			height : 24,
			items : [],
			directEdit : true
		});
		datas.on(FR.Events.CLICK,  function() {
			this.reBuild(self.getProcessPara());
		});
		datas.on(FR.Events.AFTEREDIT, function() {
			var users = $.extend({}, self.task.users, {
				paraname : this.getValue()
			});
			self.task.setUsers(users);
		});
		this.formulaText = new FS.TextEditor({
			width : 120,
			height : 24,
			directEdit : true
		});
		this.formulaText.on(FR.Events.AFTEREDIT, function() {
			var users = $.extend({}, self.task.users, {
				exp : this.getValue()
			});
			self.task.setUsers(users);
		});
		datas.setEnable(false);
		this.formulaText.setEnable(false);
		this.mainpane.append($('<table/>').append($('<tbody/>').append($('<tr/>').append($('<td/>').append(this.starter).append($('<span/>').text(''))).append($('<td/>')))
			.append($('<tr/>').append($('<td/>').append($('<div/>').append(this.processpara).append($('<span/>').text(''))))
				.append($('<td/>').append(datas.element))))	
				//wei : ȥ¼ʽ		
			//.append($('<tr/>').append($('<div/>').append(this.formula).append($('<span/>').text('¼ʽ:'))).append($('<td/>').append(this.formulaText.element)))
			.append($('<tr/>').append($('<td/>').append($('<div/>').append(this.roles).append($('<span/>').text('ѡɫ'))))
				.append($('<td/>').append(button.element))))
			.append(this.rolesTable.element).appendTo(this.element);
		this.starter.parent().css('cursor', 'pointer').click(function() {
			self.starter.click();
		});
		this.processpara.parent().css('cursor', 'pointer').click(function() {
			self.processpara.click();
		});
		this.formula.parent().css('cursor', 'pointer').click(function() {
			self.formula.click();
		});
		this.roles.parent().css('cursor', 'pointer').click(function() {
			self.roles.click();
		});
	},
	
	popTask : function(task) {
		this.clearAll();
		this.task = task;
		if (!this.task.users) {
			this.task.users = {};
		}
		
		var users = task.users;
		if (users.type == "roleusers") {
			this.roles.attr('checked', true);
			this.button.setEnable(true);
			var js = users.jroles ? users.jroles : "", ss = users.sroles ? users.sroles : "";
			this.rolesTable.popUsers(this.getRoles(js.split(','), ss.split(',')));
		} else if (users.type == "parameterusers") {
			if (users.paraname == 'processStarter') {
				this.starter.attr('checked', true);
			} else {
				this.processpara.attr('checked', true);
				this.datas.setValue(users.paraname);
			}
		} else if (users.type == "formulausers") {
			this.formula.attr('checked', true);
			this.formulaText.setValue(users.exp);	
		}
		this.task.users = users;
	},
	
	clearAll : function() {
		this.roles.attr('checked', false);
		this.starter.attr('checked', false);
		this.processpara.attr('checked', false);
		this.formula.attr('checked', false);
		this.formulaText.setValue('');
		this.rolesTable.clearContent();
		this.datas.setValue('');
	},
	
	removeSelf : function(user) {
		var js = this.task.users.jroles.split(','), ss = this.task.users.sroles.split(',');
		
		if (user.postid != null || user.departmentid != null) {
			js.remove(user.id);
		} else {
			ss.remove(user.id);
		}
		var users = $.extend({}, this.task.users, {
			jroles : js.join(','),
			sroles : ss.join(',')
		});
		this.task.setUsers(users);
	},
	
	getProcessPara : function() {
		if (!this.task) {
			return;
		}
		var paras = this.task.processDefine.parameters;
		paras = paras ? paras : [];
		var data = [];
		for (var i = 0, len = paras.length; i < len; i++) {
			data[i] = {
				text : paras[i].name,
				value : paras[i].name
			};
		}
		return data;
	},
	
	getRoles : function(jids, sids) {
		var roles = FS.Trans.getRoles();
 		for (var i = 0, len = roles.length; i < len; i++) {
 			if (roles[i].departmentname != null) {
 				roles[i].text = roles[i].departmentname + roles[i].postname;
 			}				
 		}
 		if (jids || sids) {
 			var rs = [];
 			for (var i = 0, len = roles.length; i < len; i++) {
 				if (jids.indexOf(roles[i].id) > -1 && roles[i].departmentname != null) {
 					rs.push(roles[i]);
 				}
 				if (sids.indexOf(roles[i].id) > -1 && roles[i].departmentname == null) {
 					rs.push(roles[i]);
 				}
 			}
 			return rs;
 		}
 		return roles;
	},
	
	string2Ids : function(s) {
		
	},
	
	setRoleIDS : function(roles) {
		var roles = roles ? roles : this.rolesTable.getUsers();
		if (!roles) {
			return;
		}
		for (var i = 0, len = roles.length; i < len; i++) {
			this.rolesList.selecteByID([roles[i].id], 'departmentname', roles[i].departmentname != null);
		}
	},
	
	changeRoles : function(roles) {
		if (!this.task || !roles || roles.length < 1) {
			return;
		}
		var jr = [], sr = [];
		for (var i = 0, len = roles.length; i < len; i++) {
			if (roles[i].departmentname) {
				jr.push(roles[i].id);
			} else {
				sr.push(roles[i].id);
			}
		}
		var users = $.extend({}, this.task.users, {
			jroles : jr.join(','),
			sroles : sr.join(',')
		});
		this.task.setUsers(users);
	},
	
	showRolesDialog : function(roles) {
		if (this.rolesDialog) {
			this.setRoleIDS(roles);
			this.rolesDialog.setVisible(true);
			return;
		}

		this.rolesList = new FS.List({
			width : 140,
			height : 280,
			multi : true,
			items : this.getRoles()
		});
		var self = this;

		this.rolesList.element.attr('id', 'fs_process_roleslist');
		var confire = function() {
			var roles = self.rolesList.getSelectedDatas();
			self.rolesTable.popUsers(roles);	
			self.changeRoles(roles);
		};
		
		var content = $('<div/>').addClass('fs_process_rolepane').append(this.rolesList.element);
		this.setRoleIDS(roles);
		this.usersDialog = new FS.Dialog({
			title : 'ѡɫ',
		 	width : 240,
		 	height : 360,
		 	confire : confire,
		 	content : content
		});
	},
	
	createRadio : function() {
		var self = this;
		var radio =  $('<input/>').attr({
			type : 'radio',
			checked : false,
			name : 'users'
		});
		return radio;
	},
	
	setUesr : function() {
		
	},
	
	getUser : function() {
		
	},
	
	hide : function() {
		
	}
});

FS.TaskShift = FS.extend(FS.Widget, {
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_process_taskshift');
		this.generateShiftPane();	
	},
	
	generateShiftPane : function() {		
		this.trancombo  = new FS.Combobox({
			width : 120,
			height : 24,
			items : [],
			directEdit : true,
			allowBlank : false
		});
		var self = this;
		this.trancombo.on(FR.Events.CLICK,  function() {
			this.reBuild(self.getTranNames());
		});
		this.trancombo.element.css({
			position : 'absolute',
			left : 100,
			top : 0
		});
		$('<div/>').css({
			position : 'absolute',
			left : 10,
			top : 10
		}).append($('<span/>').text('ѡ̷֧:')).append(this.trancombo.element).appendTo(this.element);
		$('<span/>').css({
			position : 'absolute',
			top : 40,
			left : 10
		}).text('֧ת:').appendTo(this.element);
		$('<div/>').css({
			position : 'absolute',
			top : 60,
			left : 10
		}).append(this.createDesignTable()).appendTo(this.element);
		this.createOPButtons();
		this.createConditionPane();
	},
	
	getTranNames : function() {
		var trans = [];
		if (this.task.transitions) {
			for (var i = 0, len = this.task.transitions.length; i < len; i++) {
				trans[i] = {
					text : this.task.transitions[i].getName(),
					value : this.task.transitions[i].getName()
				};
			}
		}
		return trans;
	},

									
	createDesignTable : function() {
		return $('<table/>').append(this.generateExplanTR()).append(this.generateFilterTR());
	},
									
	generateExplanTR : function() {
		return $('<thead/>').append($('<th/>').text('ѡ̲'))
			.append($('<th/>').text(''))
			.append($('<th/>').text('ͣ'))
			.append($('<th/>').text('ֵ'));
	},
									
	generateFilterTR : function() {
		return $('<tr/>').addClass('adhoc_design_filterdata_filtertr')
			.append($('<td/>').append(this.generateParaCombo()))
			.append($('<td/>').append(this.generateOPCombo()))
			.append($('<td/>').append(this.generateTypeCombo()))
			.append($('<td/>').append(this.valuePane()));
	},
									
	generateParaCombo : function() {
		this.paracombo  = new FS.Combobox({
			width : 100,
			height : 24,
			items : [],
			directEdit : true,
			allowBlank : false
		});
		var self = this;
		this.paracombo.on(FR.Events.CLICK,  function() {
			this.reBuild(self.getProcessPara());
		});
		return this.paracombo.element;
	},
	
	getProcessPara : function() {
		if (!this.task) {
			return;
		}
		var paras = this.task.processDefine.parameters;
		paras = paras ? paras : [];
		var data = [];
		for (var i = 0, len = paras.length; i < len; i++) {
			data[i] = {
				text : paras[i].name,
				value : paras[i].name
			};
		}
		//b:ֱӿͻȡ̲
		if (this.task.subname != null) {
			Array.prototype.push.apply(data, FS.Design.processPane.getProcessPara(this.task.subname));
		}
		
		return data;
	},
									
									
	generateOPCombo : function() {	
		this.opcombo  = new FS.Combobox({
			width : 80,
			height : 24,
			items : this.opData(),
			directEdit : false,
			allowBlank : false
		});	
		return this.opcombo.element;
	},
									
	opData : function() {
		var item = [];
		item.push({text: FR.i18n.ConditionB_equals, value: 0});
		item.push({text: FR.i18n.ConditionB_does_not_equal_to, value: 1});
		item.push({text: FR.i18n.ConditionB_is_greater_than, value: 2});
		item.push({text: FR.i18n.ConditionB_is_greater_than_or_equal_to, value: 3});	
		item.push({text: FR.i18n.ConditionB_is_less_than, value: 4});
		item.push({text: FR.i18n.ConditionB_is_less_than_or_equal_to, value: 5});
//		item.push({text: FR.i18n.ConditionB_begins_with, value: 6});
//		item.push({text: FR.i18n.ConditionB_does_not_begin_with, value: 7});
//		item.push({text: FR.i18n.ConditionB_ends_with, value: 8});
//		item.push({text: FR.i18n.ConditionB_does_not_end_with, value: 9});
//		item.push({text: FR.i18n.ConditionB_contains, value: 10});
//		item.push({text: FR.i18n.ConditionB_does_not_contain, value: 11});
//		item.push({text: FR.i18n.ConditionB_in, value: 12});
//		item.push({text: FR.i18n.ConditionB_does_not_in, value: 13});
		return item;
	},
									
	generateTypeCombo : function() {
		this.typecombo  = new FS.Combobox({
			width : 80,
			height : 24,
			items : this.typeData(),
			directEdit : false,
			allowBlank : false
		});	
		return this.typecombo.element;
	},
																		
	typeData : function() {
		var item = [];
		item.push({text: FR.i18n.Parameter_String, value: 'string'});
		item.push({text: FR.i18n.Number, value: 'number'});
//		item.push({text: FR.i18n.Date, value: 'date'});
		return item;
	},
	
	valuePane : function() {
		this.valueText = new FS.TextEditor({
			width : 100,
			height : 24,
			allowBlank : false
		});
		return this.valueText.element;
	},
	
	createOPButtons : function() {
		var self = this;
		this.addcondition = new FS.IconButton({
			baseClass : 'fr_auth_addposition',
			renderEl : $('<div/>'),
			title : '',
			handler : function() {
				self.addNewCondition();	
			}
		});
		
		this.addcondition.element.css({
			position : 'absolute',
			top : 50,
			left : 400
		});
		
		this.editcondition = new FS.IconButton({
			baseClass : 'fr_auth_editposition',
			renderEl : $('<div/>'),
			title : '޸',
			disabled : true,
			handler : function() {
				self.changeCondition();	
			}
		});
		
		this.editcondition.element.css({
			position : 'absolute',
			top : 80,
			left : 400
		});
		this.element.append(this.addcondition.element).append(this.editcondition.element);
	},
	
	addNewCondition : function() {
		var condition = this.getCondition();
		if (condition) {
			this.addCondition(condition);
			this.task.addCondition(condition);
		}
	},
	
	addCondition : function(condition) {
		condition.text = this.generateName4Condition(condition);
		this.conditionList.addSimpleData(condition);
	},
	
	createConditionPane : function() {
		this.conditionList = new FS.RemoveList({
 			width : 320,
 			height : 160,	
 			items : this.getConditions()
 		});
 		this.conditionList.element.css({
 			position : 'absolute',
 			top : 10,
 			left : 440
 		});
 		var self = this;
 		this.conditionList.on(FR.Events.REMOVEDATA, function(condition) {
			self.task.removeCondition(condition);
 		});
 		this.conditionList.on(FR.Events.CLICK, function() {
			self.showCondition();
			self.editcondition.setEnable(true);
 		});
 		this.conditionList.on(FR.Events.NOSELECT, function() {	
			self.editcondition.setEnable(false);
		});
 		this.element.append(this.conditionList.element);
	},
	
	showCondition : function() {
		var condition = this.conditionList.getSelectedData();
		this.trancombo.setValue(condition.transitionname);
		this.paracombo.setValue(condition.paraname);
		var comp = condition.comp;
		this.opcombo.setValue(comp.op);
		this.typecombo.setValue(comp.type);
		this.valueText.setValue(comp.value);
	},
	
	generateName4Condition : function(condition) {

		return '֧:' + condition.transitionname + ' :' + condition.paraname + this.getOPName(condition.comp.op) + condition.comp.value + '';
	},
	
	getOPName : function(value) {
		var ops = this.opData();
		for (var i = 0, len = ops.length; i < len; i++) {
			if (ops[i].value == value) {
				return ops[i].text;
			}
		}
	},
	
	changeCondition : function() {
		var condition = this.getCondition(), selecteddata = this.conditionList.getSelectedData();
		if (condition && selecteddata) {
			condition.text = this.generateName4Condition(condition);
			condition = $.extend({}, selecteddata, condition);
			this.task.editCondition(condition, selecteddata);
			this.conditionList.editItem(condition);	
		}
	},
	
	getCondition : function() {
		if (!this.checkCondition()) {
			return;
		}
		return {
			transitionname : this.trancombo.getValue(),
			paraname : this.paracombo.getValue(),
			comp : {
				op : this.opcombo.getValue(),
				type : this.typecombo.getValue(),
				value : this.valueText.getValue()
			}
		};
	},
	
	checkCondition : function() {
		if (!this.trancombo.checkValidate()) {
			return;
		}
		if (!this.paracombo.checkValidate()) {
			return;
		}
		if (!this.opcombo.checkValidate()) {
			return;
		}
		if (!this.typecombo.checkValidate()) {
			return;
		}
		if (!this.valueText.checkValidate()) {
			return;
		}
		return true;
	},
	
	getConditions : function() {
		if (!this.task) {
			return [];
		}
	},
	
	popTask : function(task) {
		this.task = task;
		if (task.conditiontransitions) {
			var conditions = task.conditiontransitions;
			for (var i = 0, len = conditions.length; i < len; i++) {
				conditions[i].text = this.generateName4Condition(conditions[i]);
			}
			this.conditionList.reBuild(conditions);
		}
	}
});

FS.TaskPane = FS.extend(FS.Widget, {
	paneHeight : 180,
	
	init : function(config) {
		this.element = $('<div/>').attr('id', 'fs_process_taskpane').css('z-index', 8);
		this.container = config.container;
		this.initPane();
		this.collapse = true;
	},
	
	//b:ؼԷطʹãfs buttontabpane
	initPane : function() {
		var self = this;
		this.expandicon = $('<div/>').css({
			position : 'absolute',
			top : 1,
			left : 0,
			width : 12,
			height : 8
		});
		this.expandContent = $('<div/>').addClass('fs_taskpane_expand').css('height', 10).click(function() {
			self.collapseOrExpand();
			if (self.collapse) {
				$(this).switchClass('fs_taskpane_expand', 'fs_taskpane_collapse');
			} else {
				$(this).switchClass('fs_taskpane_collapse', 'fs_taskpane_expand');
			}
		}).mouseover(function() {
			$(this).addClass('fs_taskpane_active');
		}).mouseout(function() {
			$(this).removeClass('fs_taskpane_active');
		}).append(this.expandicon).appendTo(this.element);
		
		
		this.toolbar = $('<div/>').attr('id', 'fs_taskpane_toolbar').css({
			position : 'absolute',
			top : 10,
			left : 0,
			width : 120,
			background : '#BEE5FD'
		});
		this.basebutton = new FS.ToolbarButton({
			text : '',
			height : 24,
			width : 116,			
			handler : function() {
				self.showPane();								
			}
		});
		this.basebutton.element.css({
			position : 'absolute',
			left : 1,
			top : 1
		}).appendTo(this.toolbar);
		this.userbutton = new FS.ToolbarButton({
			text : '',
			height : 24,
			width : 116,			
			handler : function() {
				self.showPane('user');								
			}
		});
		this.userbutton.element.css({
			position : 'absolute',
			left : 1,
			top : 27
		}).appendTo(this.toolbar);
		this.shiftbutton = new FS.ToolbarButton({
			text : 'ת',
			height : 24,
			width : 116,			
			handler : function() {
				self.showPane('shift');								
			}
		});
		this.shiftbutton.element.css({
			position : 'absolute',
			left : 1,
			top : 27
		}).appendTo(this.toolbar);
		this.toolbar.appendTo(this.element);
		
		this.paneContainer = $('<div/>').addClass('fs_taskpane_container').css({
			position : 'absolute',
			left : 120,
			top : 10
		}).appendTo(this.element);
		
		//b:Ҫʱcreateto do
		this.basepane = new FS.TaskBasic();
		this.userpane = new FS.TaskUser();
		this.shiftpane = new FS.TaskShift();
		this.basepane.element.hide().appendTo(this.paneContainer);
		this.userpane.element.hide().appendTo(this.paneContainer);
		this.shiftpane.element.hide().appendTo(this.paneContainer);
		
		
//		this.tab = new FS.ProcessTab({
//			items : [{
//				title : ''
//			}, {
//				title : ''
//			}]
//		});
//		this.taskBasic = new FS.TaskBasic();
//		this.taskUser = new FS.TaskUser();
//		var self = this;
//		this.tab.on(FR.Events.TABCHANGE, function(tabpane, index) {
//			var container = tabpane.options.tabs[index].content;
//			if (container.children().length > 0) {
//				return;
//			}
//			var rp = null;
//			if (index == 0) {
//				rp = self.taskBasic.element;
//			} else {
//				rp = self.taskUser.element;
//			}
//			container.append(rp);
//		});
//		this.tab.on(FR.Events.CollapseOrExpand, function() {
//			self.collapseOrExpand();	
//		});
//		this.element.append(this.tab.element);
//		setTimeout(function(){
//			self.tab.fireEvent(FR.Events.TABCHANGE, self.tab, 0);
//		}, 25);
	},
	
	showPane : function(type) {
		var base = true, user = false, shift = false;
		if (type == 'user') {
			base = false, user = true;
		} else if (type == 'shift') {
			base = false, shift = true;
		}
		this.basebutton.element[base ? 'addClass' : 'removeClass']('fs_button_selected');
		this.userbutton.element[user ? 'addClass' : 'removeClass']('fs_button_selected');
		this.shiftbutton.element[shift ? 'addClass' : 'removeClass']('fs_button_selected');

		this.basepane.element[base ? 'show' : 'hide']();
		this.userpane.element[user ? 'show' : 'hide']();
		this.shiftpane.element[shift ? 'show' : 'hide']();
	},
	
	resize : function(rec) {
		this.element.width(rec.width);
		this.expandContent.width(rec.width);
		this.expandicon.css('left', rec.width/2 - 5);
		this.paneContainer.width(rec.width - this.toolbar.width());
		var height = this.collapse ? 0 : this.paneHeight;
		this.element.height(this.expandContent.height() + height);
		this.toolbar.height(height);
		this.paneContainer.height(height);
	},
	
	collapseOrExpand : function() {
		if (this.collapse) {
			this.expandPane();
		} else {
			this.collapsePane();
		}
	},
	
	collapsePane : function() {
		this.element.height(this.expandContent.height());
		this.collapse = true;
		this.confirmContainer();
	},
	
	expandPane : function() {
		this.element.height(this.expandContent.height() + this.paneHeight);
		this.collapse = false;
		this.confirmContainer();
	},
	
	hideContent : function() {		
		this.toolbar.hide();
		this.paneContainer.hide();
	},
	
	showContent : function(task) {
		this.toolbar.show();
		if (task.getType() == "formtask") {
			this.userbutton.setVisible(true);
		} else {
			this.userbutton.setVisible(false);
		}
		if (task.getType() == "subprotask" ) {
			this.shiftbutton.setVisible(true);
		} else {
			this.shiftbutton.setVisible(false);
		}

		this.paneContainer.show();
	},
	
	confirmContainer : function() {
		if (this.container) {
			var el = this.container.element;
			this.container.resize({
				width : el.width(),
				height : el.height()
			});
		}
	},
	
	isCollapse : function() {
		return this.collapse;
	},
	
	fireContentByTask : function(task) {
		if (!task) {
			this.hideContent();
			this.collapsePane();
		} else {
			this.showContent(task);
			this.expandPane();
			return true;
		}
	},
		
	popTask : function(task) {
		if (!this.fireContentByTask(task)) {
			return;
		}
		var type = task.getType();
		this.basebutton.fireEvent(FR.Events.CLICK);
		
		this.basepane.popTask(task);
		if (type == 'formtask') {
			this.userpane.popTask(task);
		}
		if (type == 'subprotask') {
			this.shiftpane.popTask(task);
		}
	}
});